/* PopupWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from PopupWindow.vala, do not modify */

/*
 * Copyright 2017 Adam Bieńkowski
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala-pip.h"
#include <glib.h>
#include "gala.h"
#include <meta/meta-window-actor.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <meta/window.h>
#include <glib-object.h>
#include <graphene-gobject.h>
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <meta/common.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>
#include <mtk/mtk.h>

#define GALA_PLUGINS_PIP_POPUP_WINDOW_FADE_OUT_TIMEOUT ((guint) 200)
#define GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE 0.1f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE 1.0f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN 0
#define GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT 0.5f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS 80
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_PLUGINS_PIP_POPUP_WINDOW_0_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_PROPERTIES
};
static GParamSpec* gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _clutter_grab_unref0(var) ((var == NULL) ? NULL : (var = (clutter_grab_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
enum  {
	GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL,
	GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_SIGNALS
};
static guint gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_SIGNALS] = {0};

struct _GalaPluginsPIPPopupWindowPrivate {
	gint button_size;
	gint container_margin;
	GalaWindowManager* _wm;
	MetaWindowActor* _window_actor;
	ClutterClone* clone;
	ClutterActor* clone_container;
	ClutterActor* container;
	GalaCloseButton* close_button;
	ClutterActor* resize_button;
	GalaDragDropAction* move_action;
	gfloat begin_resize_width;
	gfloat begin_resize_height;
	gfloat resize_start_x;
	gfloat resize_start_y;
	gboolean resizing;
	gboolean off_screen;
	ClutterGrab* grab;
};

struct _Block4Data {
	int _ref_count_;
	GalaPluginsPIPPopupWindow* self;
	gulong completed_id;
};

static gint GalaPluginsPIPPopupWindow_private_offset;
static gpointer gala_plugins_pip_popup_window_parent_class = NULL;
static MetaWindow* gala_plugins_pip_popup_window_previous_focus;
static MetaWindow* gala_plugins_pip_popup_window_previous_focus = NULL;

static void gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (gfloat src_width,
                                                                    gfloat src_height,
                                                                    gfloat max_width,
                                                                    gfloat max_height,
                                                                    gfloat* width,
                                                                    gfloat* height);
static gboolean gala_plugins_pip_popup_window_get_window_is_normal (MetaWindow* window);
static void gala_plugins_pip_popup_window_real_show (ClutterActor* base);
static void gala_plugins_pip_popup_window_real_hide (ClutterActor* base);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void ___lambda4_ (Block4Data* _data4_);
static void ____lambda4__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                       gpointer self);
static gboolean gala_plugins_pip_popup_window_real_enter_event (ClutterActor* base,
                                                         ClutterEvent* event);
static gboolean gala_plugins_pip_popup_window_real_leave_event (ClutterActor* base,
                                                         ClutterEvent* event);
static void gala_plugins_pip_popup_window_update_clone_container_scale (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_allocation_changed (GalaPluginsPIPPopupWindow* self);
static ClutterActor* gala_plugins_pip_popup_window_on_move_begin (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_move_end (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_screen_position (GalaPluginsPIPPopupWindow* self);
static gboolean gala_plugins_pip_popup_window_on_resize_button_press (GalaPluginsPIPPopupWindow* self,
                                                               ClutterEvent* event);
static gboolean gala_plugins_pip_popup_window_on_resize_event (GalaPluginsPIPPopupWindow* self,
                                                        ClutterEvent* event);
static gboolean _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event (ClutterActor* _sender,
                                                                             ClutterEvent* event,
                                                                             gpointer self);
static void gala_plugins_pip_popup_window_stop_resizing (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_size (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_clone_clip (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_close_click_clicked (GalaPluginsPIPPopupWindow* self);
static gboolean __lambda5_ (GalaPluginsPIPPopupWindow* self);
static gboolean ___lambda5__gsource_func (gpointer self);
static void gala_plugins_pip_popup_window_update_window_focus (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_get_target_window_size (GalaPluginsPIPPopupWindow* self,
                                                           gfloat* width,
                                                           gfloat* height);
static void gala_plugins_pip_popup_window_update_clone_container_position (GalaPluginsPIPPopupWindow* self);
static gboolean gala_plugins_pip_popup_window_place_window_off_screen (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_place_window_in_screen (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_get_current_monitor_rect (GalaPluginsPIPPopupWindow* self,
                                                             MtkRectangle* rect);
static gboolean gala_plugins_pip_popup_window_coord_is_in_other_monitor (GalaPluginsPIPPopupWindow* self,
                                                                  gfloat coord,
                                                                  ClutterOrientation axis);
static void gala_plugins_pip_popup_window_activate (GalaPluginsPIPPopupWindow* self);
static GObject * gala_plugins_pip_popup_window_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static ClutterActor* _gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin (GalaDragDropAction* _sender,
                                                                                             gfloat x,
                                                                                             gfloat y,
                                                                                             gpointer self);
static void _gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled (GalaDragDropAction* _sender,
                                                                                     gpointer self);
static void _gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked (GalaDragDropAction* _sender,
                                                                                  guint32 button,
                                                                                  gpointer self);
static void _gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered (GalaCloseButton* _sender,
                                                                                        guint32 timestamp,
                                                                                        gpointer self);
static gboolean _gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                                 ClutterEvent* event,
                                                                                                 gpointer self);
static void _gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify (GObject* _sender,
                                                                           GParamSpec* pspec,
                                                                           gpointer self);
static void _gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged (MetaWindow* _sender,
                                                                                  gpointer self);
static void _gala_plugins_pip_popup_window_update_window_focus_g_object_notify (GObject* _sender,
                                                                         GParamSpec* pspec,
                                                                         gpointer self);
static void _gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                                         gpointer self);
static void gala_plugins_pip_popup_window_finalize (GObject * obj);
static GType gala_plugins_pip_popup_window_get_type_once (void);
static void _vala_gala_plugins_pip_popup_window_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_gala_plugins_pip_popup_window_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

static inline gpointer
gala_plugins_pip_popup_window_get_instance_private (GalaPluginsPIPPopupWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GalaPluginsPIPPopupWindow_private_offset);
}

static void
gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (gfloat src_width,
                                                               gfloat src_height,
                                                               gfloat max_width,
                                                               gfloat max_height,
                                                               gfloat* width,
                                                               gfloat* height)
{
	gfloat _vala_width = 0.0F;
	gfloat _vala_height = 0.0F;
	gfloat ratio = 0.0F;
#line 43 "../plugins/pip/PopupWindow.vala"
	ratio = MIN (max_width / src_width, max_height / src_height);
#line 44 "../plugins/pip/PopupWindow.vala"
	_vala_width = src_width * ratio;
#line 45 "../plugins/pip/PopupWindow.vala"
	_vala_height = src_height * ratio;
#line 41 "../plugins/pip/PopupWindow.vala"
	if (width) {
#line 41 "../plugins/pip/PopupWindow.vala"
		*width = _vala_width;
#line 205 "PopupWindow.c"
	}
#line 41 "../plugins/pip/PopupWindow.vala"
	if (height) {
#line 41 "../plugins/pip/PopupWindow.vala"
		*height = _vala_height;
#line 211 "PopupWindow.c"
	}
}

static gboolean
gala_plugins_pip_popup_window_get_window_is_normal (MetaWindow* window)
{
	MetaWindowType window_type = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 48 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (window != NULL, FALSE);
#line 49 "../plugins/pip/PopupWindow.vala"
	window_type = meta_window_get_window_type (window);
#line 50 "../plugins/pip/PopupWindow.vala"
	if (window_type == META_WINDOW_NORMAL) {
#line 50 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = TRUE;
#line 230 "PopupWindow.c"
	} else {
#line 51 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = window_type == META_WINDOW_DIALOG;
#line 234 "PopupWindow.c"
	}
#line 50 "../plugins/pip/PopupWindow.vala"
	if (_tmp1_) {
#line 50 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = TRUE;
#line 240 "PopupWindow.c"
	} else {
#line 52 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = window_type == META_WINDOW_MODAL_DIALOG;
#line 244 "PopupWindow.c"
	}
#line 50 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 50 "../plugins/pip/PopupWindow.vala"
	return result;
#line 250 "PopupWindow.c"
}

GalaPluginsPIPPopupWindow*
gala_plugins_pip_popup_window_construct (GType object_type,
                                         GalaWindowManager* wm,
                                         MetaWindowActor* window_actor)
{
	GalaPluginsPIPPopupWindow * self = NULL;
#line 55 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 55 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (window_actor != NULL, NULL);
#line 56 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) g_object_new (object_type, "wm", wm, "window-actor", window_actor, NULL);
#line 55 "../plugins/pip/PopupWindow.vala"
	return self;
#line 267 "PopupWindow.c"
}

GalaPluginsPIPPopupWindow*
gala_plugins_pip_popup_window_new (GalaWindowManager* wm,
                                   MetaWindowActor* window_actor)
{
#line 55 "../plugins/pip/PopupWindow.vala"
	return gala_plugins_pip_popup_window_construct (GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, wm, window_actor);
#line 276 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_real_show (ClutterActor* base)
{
	GalaPluginsPIPPopupWindow * self;
	gint _tmp0_ = 0;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 140 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 141 "../plugins/pip/PopupWindow.vala"
	CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->show (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 143 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 145 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 146 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 146 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 146 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 146 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 146 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 200;
#line 305 "PopupWindow.c"
	} else {
#line 146 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 0;
#line 309 "PopupWindow.c"
	}
#line 146 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) _tmp0_);
#line 147 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 255);
#line 148 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 317 "PopupWindow.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 160 "../plugins/pip/PopupWindow.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 160 "../plugins/pip/PopupWindow.vala"
	return _data4_;
#line 327 "PopupWindow.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 160 "../plugins/pip/PopupWindow.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 337 "PopupWindow.c"
		GalaPluginsPIPPopupWindow* self;
#line 160 "../plugins/pip/PopupWindow.vala"
		self = _data4_->self;
#line 160 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self);
#line 160 "../plugins/pip/PopupWindow.vala"
		g_slice_free (Block4Data, _data4_);
#line 345 "PopupWindow.c"
	}
}

static void
___lambda4_ (Block4Data* _data4_)
{
	GalaPluginsPIPPopupWindow* self;
#line 164 "../plugins/pip/PopupWindow.vala"
	self = _data4_->self;
#line 165 "../plugins/pip/PopupWindow.vala"
	g_signal_handler_disconnect ((GObject*) self, _data4_->completed_id);
#line 166 "../plugins/pip/PopupWindow.vala"
	CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->hide (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 359 "PopupWindow.c"
}

static void
____lambda4__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                  gpointer self)
{
#line 164 "../plugins/pip/PopupWindow.vala"
	___lambda4_ (self);
#line 368 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_real_hide (ClutterActor* base)
{
	GalaPluginsPIPPopupWindow * self;
	gint _tmp0_ = 0;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint duration = 0;
#line 151 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 152 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 255);
#line 154 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 154 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 154 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 154 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 154 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 200;
#line 394 "PopupWindow.c"
	} else {
#line 154 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 0;
#line 398 "PopupWindow.c"
	}
#line 154 "../plugins/pip/PopupWindow.vala"
	duration = _tmp0_;
#line 155 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 156 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) duration);
#line 157 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 158 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 160 "../plugins/pip/PopupWindow.vala"
	if (duration == 0) {
#line 161 "../plugins/pip/PopupWindow.vala"
		CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->hide (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 414 "PopupWindow.c"
	} else {
		Block4Data* _data4_;
		gulong _tmp4_;
#line 160 "../plugins/pip/PopupWindow.vala"
		_data4_ = g_slice_new0 (Block4Data);
#line 160 "../plugins/pip/PopupWindow.vala"
		_data4_->_ref_count_ = 1;
#line 160 "../plugins/pip/PopupWindow.vala"
		_data4_->self = g_object_ref (self);
#line 163 "../plugins/pip/PopupWindow.vala"
		_data4_->completed_id = (gulong) 0;
#line 164 "../plugins/pip/PopupWindow.vala"
		_tmp4_ = g_signal_connect_data ((ClutterActor*) self, "transitions-completed", (GCallback) ____lambda4__clutter_actor_transitions_completed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 164 "../plugins/pip/PopupWindow.vala"
		_data4_->completed_id = _tmp4_;
#line 160 "../plugins/pip/PopupWindow.vala"
		block4_data_unref (_data4_);
#line 160 "../plugins/pip/PopupWindow.vala"
		_data4_ = NULL;
#line 434 "PopupWindow.c"
	}
}

static gboolean
gala_plugins_pip_popup_window_real_enter_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaPluginsPIPPopupWindow * self;
	gint _tmp0_ = 0;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint duration = 0;
	GalaCloseButton* _tmp4_;
	GalaCloseButton* _tmp5_;
	GalaCloseButton* _tmp6_;
	GalaCloseButton* _tmp7_;
	ClutterActor* _tmp8_;
	ClutterActor* _tmp9_;
	ClutterActor* _tmp10_;
	ClutterActor* _tmp11_;
	gboolean result;
#line 172 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 172 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 176 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 176 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 176 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 176 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 176 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 300;
#line 471 "PopupWindow.c"
	} else {
#line 176 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 0;
#line 475 "PopupWindow.c"
	}
#line 176 "../plugins/pip/PopupWindow.vala"
	duration = _tmp0_;
#line 178 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->close_button;
#line 178 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _tmp4_);
#line 179 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = self->priv->close_button;
#line 179 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _tmp5_, (guint) duration);
#line 180 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = self->priv->close_button;
#line 180 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp6_, (guint) 255);
#line 181 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->close_button;
#line 181 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _tmp7_);
#line 183 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->resize_button;
#line 183 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state (_tmp8_);
#line 184 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->resize_button;
#line 184 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration (_tmp9_, (guint) duration);
#line 185 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = self->priv->resize_button;
#line 185 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp10_, (guint) 255);
#line 186 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->resize_button;
#line 186 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state (_tmp11_);
#line 188 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 188 "../plugins/pip/PopupWindow.vala"
	return result;
#line 515 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_real_leave_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaPluginsPIPPopupWindow * self;
	gint _tmp0_ = 0;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint duration = 0;
	GalaCloseButton* _tmp4_;
	GalaCloseButton* _tmp5_;
	GalaCloseButton* _tmp6_;
	GalaCloseButton* _tmp7_;
	ClutterActor* _tmp8_;
	ClutterActor* _tmp9_;
	ClutterActor* _tmp10_;
	ClutterActor* _tmp11_;
	gboolean result;
#line 192 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 192 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 196 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 196 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 196 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 196 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 196 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 300;
#line 551 "PopupWindow.c"
	} else {
#line 196 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 0;
#line 555 "PopupWindow.c"
	}
#line 196 "../plugins/pip/PopupWindow.vala"
	duration = _tmp0_;
#line 198 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->close_button;
#line 198 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _tmp4_);
#line 199 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = self->priv->close_button;
#line 199 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _tmp5_, (guint) duration);
#line 200 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = self->priv->close_button;
#line 200 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp6_, (guint) 0);
#line 201 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->close_button;
#line 201 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _tmp7_);
#line 203 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->resize_button;
#line 203 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state (_tmp8_);
#line 204 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->resize_button;
#line 204 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration (_tmp9_, (guint) duration);
#line 205 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = self->priv->resize_button;
#line 205 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp10_, (guint) 0);
#line 206 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->resize_button;
#line 206 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state (_tmp11_);
#line 208 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 208 "../plugins/pip/PopupWindow.vala"
	return result;
#line 595 "PopupWindow.c"
}

void
gala_plugins_pip_popup_window_set_container_clip (GalaPluginsPIPPopupWindow* self,
                                                  graphene_rect_t* container_clip)
{
	ClutterActor* _tmp0_;
	graphene_rect_t _tmp1_;
#line 211 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 212 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 212 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = *container_clip;
#line 212 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp0_, "clip-rect", &_tmp1_, NULL);
#line 213 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_container_scale (self);
#line 214 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_allocation_changed (self);
#line 616 "PopupWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 220 "../plugins/pip/PopupWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 624 "PopupWindow.c"
}

static ClutterActor*
gala_plugins_pip_popup_window_on_move_begin (GalaPluginsPIPPopupWindow* self)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* result;
#line 217 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 218 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 218 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 218 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp1_, META_CURSOR_DND_IN_DRAG);
#line 220 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _g_object_ref0 ((ClutterActor*) self);
#line 220 "../plugins/pip/PopupWindow.vala"
	result = _tmp2_;
#line 220 "../plugins/pip/PopupWindow.vala"
	return result;
#line 648 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_move_end (GalaPluginsPIPPopupWindow* self)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
#line 223 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 224 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 225 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_screen_position (self);
#line 226 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 226 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 226 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp1_, META_CURSOR_DEFAULT);
#line 668 "PopupWindow.c"
}

static gboolean
_gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event (ClutterActor* _sender,
                                                                    ClutterEvent* event,
                                                                    gpointer self)
{
	gboolean result;
	result = gala_plugins_pip_popup_window_on_resize_event ((GalaPluginsPIPPopupWindow*) self, event);
#line 246 "../plugins/pip/PopupWindow.vala"
	return result;
#line 680 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_on_resize_button_press (GalaPluginsPIPPopupWindow* self,
                                                      ClutterEvent* event)
{
	gboolean _tmp0_ = FALSE;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	ClutterActor* _tmp7_;
	ClutterStage* _tmp8_;
	ClutterActor* _tmp9_;
	ClutterGrab* _tmp10_;
	ClutterActor* _tmp11_;
	GalaWindowManager* _tmp12_;
	MetaDisplay* _tmp13_;
	gboolean result;
#line 230 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 230 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 234 "../plugins/pip/PopupWindow.vala"
	if (self->priv->resizing) {
#line 234 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = TRUE;
#line 710 "PopupWindow.c"
	} else {
#line 234 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = clutter_event_get_button (event) != CLUTTER_BUTTON_PRIMARY;
#line 714 "PopupWindow.c"
	}
#line 234 "../plugins/pip/PopupWindow.vala"
	if (_tmp0_) {
#line 235 "../plugins/pip/PopupWindow.vala"
		result = CLUTTER_EVENT_STOP;
#line 235 "../plugins/pip/PopupWindow.vala"
		return result;
#line 722 "PopupWindow.c"
	}
#line 238 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = TRUE;
#line 240 "../plugins/pip/PopupWindow.vala"
	clutter_event_get_coords (event, &_tmp1_, &_tmp2_);
#line 240 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_x = _tmp1_;
#line 240 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_y = _tmp2_;
#line 242 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = clutter_actor_get_width ((ClutterActor*) self);
#line 242 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = _tmp3_;
#line 242 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_width = _tmp4_;
#line 243 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_height ((ClutterActor*) self);
#line 243 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 243 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_height = _tmp6_;
#line 245 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->resize_button;
#line 245 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = clutter_actor_get_stage (_tmp7_);
#line 245 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->resize_button;
#line 245 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = clutter_stage_grab (_tmp8_, _tmp9_);
#line 245 "../plugins/pip/PopupWindow.vala"
	_clutter_grab_unref0 (self->priv->grab);
#line 245 "../plugins/pip/PopupWindow.vala"
	self->priv->grab = _tmp10_;
#line 246 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->resize_button;
#line 246 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp11_, "event", (GCallback) _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event, self, 0);
#line 248 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = self->priv->_wm;
#line 248 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = meta_plugin_get_display ((MetaPlugin*) _tmp12_);
#line 248 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp13_, META_CURSOR_SE_RESIZE);
#line 250 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 250 "../plugins/pip/PopupWindow.vala"
	return result;
#line 770 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_on_resize_event (GalaPluginsPIPPopupWindow* self,
                                               ClutterEvent* event)
{
	gboolean result;
#line 253 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 253 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 254 "../plugins/pip/PopupWindow.vala"
	if (!self->priv->resizing) {
#line 255 "../plugins/pip/PopupWindow.vala"
		result = CLUTTER_EVENT_STOP;
#line 255 "../plugins/pip/PopupWindow.vala"
		return result;
#line 788 "PopupWindow.c"
	}
#line 258 "../plugins/pip/PopupWindow.vala"
	switch (clutter_event_type (event)) {
#line 258 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_MOTION:
#line 794 "PopupWindow.c"
		{
			ClutterModifierType mods = 0U;
			gfloat event_x = 0.0F;
			gfloat event_y = 0.0F;
			gfloat _tmp0_ = 0.0F;
			gfloat _tmp1_ = 0.0F;
			gfloat diff_x = 0.0F;
			gfloat diff_y = 0.0F;
#line 260 "../plugins/pip/PopupWindow.vala"
			mods = clutter_event_get_state (event);
#line 261 "../plugins/pip/PopupWindow.vala"
			if (!((mods & CLUTTER_BUTTON1_MASK) == CLUTTER_BUTTON1_MASK)) {
#line 262 "../plugins/pip/PopupWindow.vala"
				gala_plugins_pip_popup_window_stop_resizing (self);
#line 263 "../plugins/pip/PopupWindow.vala"
				break;
#line 811 "PopupWindow.c"
			}
#line 267 "../plugins/pip/PopupWindow.vala"
			clutter_event_get_coords (event, &_tmp0_, &_tmp1_);
#line 267 "../plugins/pip/PopupWindow.vala"
			event_x = _tmp0_;
#line 267 "../plugins/pip/PopupWindow.vala"
			event_y = _tmp1_;
#line 268 "../plugins/pip/PopupWindow.vala"
			diff_x = event_x - self->priv->resize_start_x;
#line 269 "../plugins/pip/PopupWindow.vala"
			diff_y = event_y - self->priv->resize_start_y;
#line 271 "../plugins/pip/PopupWindow.vala"
			clutter_actor_set_width ((ClutterActor*) self, self->priv->begin_resize_width + diff_x);
#line 272 "../plugins/pip/PopupWindow.vala"
			clutter_actor_set_height ((ClutterActor*) self, self->priv->begin_resize_height + diff_y);
#line 274 "../plugins/pip/PopupWindow.vala"
			gala_plugins_pip_popup_window_update_clone_container_scale (self);
#line 275 "../plugins/pip/PopupWindow.vala"
			gala_plugins_pip_popup_window_update_size (self);
#line 277 "../plugins/pip/PopupWindow.vala"
			break;
#line 833 "PopupWindow.c"
		}
#line 258 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_BUTTON_RELEASE:
#line 837 "PopupWindow.c"
		{
#line 279 "../plugins/pip/PopupWindow.vala"
			if (clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY) {
#line 280 "../plugins/pip/PopupWindow.vala"
				gala_plugins_pip_popup_window_stop_resizing (self);
#line 843 "PopupWindow.c"
			}
#line 283 "../plugins/pip/PopupWindow.vala"
			break;
#line 847 "PopupWindow.c"
		}
#line 258 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_LEAVE:
#line 258 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_ENTER:
#line 853 "PopupWindow.c"
		{
#line 286 "../plugins/pip/PopupWindow.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 286 "../plugins/pip/PopupWindow.vala"
			return result;
#line 859 "PopupWindow.c"
		}
		default:
		{
#line 288 "../plugins/pip/PopupWindow.vala"
			break;
#line 865 "PopupWindow.c"
		}
	}
#line 291 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_STOP;
#line 291 "../plugins/pip/PopupWindow.vala"
	return result;
#line 872 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_stop_resizing (GalaPluginsPIPPopupWindow* self)
{
	ClutterGrab* _tmp0_;
	GalaWindowManager* _tmp4_;
	MetaDisplay* _tmp5_;
#line 294 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 295 "../plugins/pip/PopupWindow.vala"
	if (!self->priv->resizing) {
#line 296 "../plugins/pip/PopupWindow.vala"
		return;
#line 887 "PopupWindow.c"
	}
#line 299 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->grab;
#line 299 "../plugins/pip/PopupWindow.vala"
	if (_tmp0_ != NULL) {
#line 893 "PopupWindow.c"
		ClutterGrab* _tmp1_;
		ClutterActor* _tmp2_;
		guint _tmp3_;
#line 300 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = self->priv->grab;
#line 300 "../plugins/pip/PopupWindow.vala"
		clutter_grab_dismiss (_tmp1_);
#line 301 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = self->priv->resize_button;
#line 301 "../plugins/pip/PopupWindow.vala"
		g_signal_parse_name ("event", clutter_actor_get_type (), &_tmp3_, NULL, FALSE);
#line 301 "../plugins/pip/PopupWindow.vala"
		g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event, self);
#line 302 "../plugins/pip/PopupWindow.vala"
		_clutter_grab_unref0 (self->priv->grab);
#line 302 "../plugins/pip/PopupWindow.vala"
		self->priv->grab = NULL;
#line 911 "PopupWindow.c"
	}
#line 305 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = FALSE;
#line 307 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_screen_position (self);
#line 309 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->_wm;
#line 309 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = meta_plugin_get_display ((MetaPlugin*) _tmp4_);
#line 309 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp5_, META_CURSOR_DEFAULT);
#line 923 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_allocation_changed (GalaPluginsPIPPopupWindow* self)
{
#line 312 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 313 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_clip (self);
#line 314 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_size (self);
#line 935 "PopupWindow.c"
}

static gboolean
__lambda5_ (GalaPluginsPIPPopupWindow* self)
{
	gboolean result;
#line 326 "../plugins/pip/PopupWindow.vala"
	g_signal_emit (self, gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL], 0);
#line 327 "../plugins/pip/PopupWindow.vala"
	result = G_SOURCE_REMOVE;
#line 327 "../plugins/pip/PopupWindow.vala"
	return result;
#line 948 "PopupWindow.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((GalaPluginsPIPPopupWindow*) self);
#line 325 "../plugins/pip/PopupWindow.vala"
	return result;
#line 958 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_close_click_clicked (GalaPluginsPIPPopupWindow* self)
{
	guint _tmp0_ = 0U;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	guint duration = 0U;
#line 317 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 318 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 318 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 318 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 318 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 318 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = GALA_PLUGINS_PIP_POPUP_WINDOW_FADE_OUT_TIMEOUT;
#line 981 "PopupWindow.c"
	} else {
#line 318 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = (guint) 0;
#line 985 "PopupWindow.c"
	}
#line 318 "../plugins/pip/PopupWindow.vala"
	duration = _tmp0_;
#line 320 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 321 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, duration);
#line 322 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 323 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 325 "../plugins/pip/PopupWindow.vala"
	clutter_threads_add_timeout (duration, ___lambda5__gsource_func, self);
#line 999 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_window_focus (GalaPluginsPIPPopupWindow* self)
{
	MetaWindow* focus_window = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWindow* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	MetaWindow* _tmp5_;
	MetaWorkspaceManager* workspace_manager = NULL;
	GalaWindowManager* _tmp11_;
	MetaDisplay* _tmp12_;
	MetaWorkspaceManager* _tmp13_;
	MetaWorkspace* active_workspace = NULL;
	MetaWorkspaceManager* _tmp14_;
	MetaWorkspace* _tmp15_;
	MetaWindow* window = NULL;
	MetaWindowActor* _tmp16_;
	MetaWindow* _tmp17_;
	gboolean _tmp18_ = FALSE;
	MetaWindow* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	MetaWindow* _tmp25_;
#line 331 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 332 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 332 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 332 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = meta_display_get_focus_window (_tmp1_);
#line 332 "../plugins/pip/PopupWindow.vala"
	focus_window = _tmp2_;
#line 333 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = focus_window;
#line 333 "../plugins/pip/PopupWindow.vala"
	if (_tmp5_ != NULL) {
#line 1041 "PopupWindow.c"
		MetaWindow* _tmp6_;
#line 333 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = focus_window;
#line 333 "../plugins/pip/PopupWindow.vala"
		_tmp4_ = !gala_plugins_pip_popup_window_get_window_is_normal (_tmp6_);
#line 1047 "PopupWindow.c"
	} else {
#line 333 "../plugins/pip/PopupWindow.vala"
		_tmp4_ = FALSE;
#line 1051 "PopupWindow.c"
	}
#line 333 "../plugins/pip/PopupWindow.vala"
	if (_tmp4_) {
#line 333 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = TRUE;
#line 1057 "PopupWindow.c"
	} else {
		gboolean _tmp7_ = FALSE;
		MetaWindow* _tmp8_;
#line 334 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = gala_plugins_pip_popup_window_previous_focus;
#line 334 "../plugins/pip/PopupWindow.vala"
		if (_tmp8_ != NULL) {
#line 1065 "PopupWindow.c"
			MetaWindow* _tmp9_;
#line 334 "../plugins/pip/PopupWindow.vala"
			_tmp9_ = gala_plugins_pip_popup_window_previous_focus;
#line 334 "../plugins/pip/PopupWindow.vala"
			_tmp7_ = !gala_plugins_pip_popup_window_get_window_is_normal (_tmp9_);
#line 1071 "PopupWindow.c"
		} else {
#line 334 "../plugins/pip/PopupWindow.vala"
			_tmp7_ = FALSE;
#line 1075 "PopupWindow.c"
		}
#line 334 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = _tmp7_;
#line 1079 "PopupWindow.c"
	}
#line 333 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 1083 "PopupWindow.c"
		MetaWindow* _tmp10_;
#line 335 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = focus_window;
#line 335 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_previous_focus = _tmp10_;
#line 336 "../plugins/pip/PopupWindow.vala"
		return;
#line 1091 "PopupWindow.c"
	}
#line 339 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->_wm;
#line 339 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = meta_plugin_get_display ((MetaPlugin*) _tmp11_);
#line 339 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = meta_display_get_workspace_manager (_tmp12_);
#line 339 "../plugins/pip/PopupWindow.vala"
	workspace_manager = _tmp13_;
#line 340 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = workspace_manager;
#line 340 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = meta_workspace_manager_get_active_workspace (_tmp14_);
#line 340 "../plugins/pip/PopupWindow.vala"
	active_workspace = _tmp15_;
#line 341 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = self->priv->_window_actor;
#line 341 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = meta_window_actor_get_meta_window (_tmp16_);
#line 341 "../plugins/pip/PopupWindow.vala"
	window = _tmp17_;
#line 343 "../plugins/pip/PopupWindow.vala"
	_tmp19_ = window;
#line 343 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp19_, "appears-focused", &_tmp20_, NULL);
#line 343 "../plugins/pip/PopupWindow.vala"
	_tmp21_ = _tmp20_;
#line 343 "../plugins/pip/PopupWindow.vala"
	if (_tmp21_) {
#line 1121 "PopupWindow.c"
		MetaWindow* _tmp22_;
		MetaWorkspace* _tmp23_;
#line 343 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = window;
#line 343 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = active_workspace;
#line 343 "../plugins/pip/PopupWindow.vala"
		_tmp18_ = meta_window_located_on_workspace (_tmp22_, _tmp23_);
#line 1130 "PopupWindow.c"
	} else {
#line 343 "../plugins/pip/PopupWindow.vala"
		_tmp18_ = FALSE;
#line 1134 "PopupWindow.c"
	}
#line 343 "../plugins/pip/PopupWindow.vala"
	if (_tmp18_) {
#line 344 "../plugins/pip/PopupWindow.vala"
		clutter_actor_hide ((ClutterActor*) self);
#line 1140 "PopupWindow.c"
	} else {
		MetaWindowActor* _tmp24_;
#line 345 "../plugins/pip/PopupWindow.vala"
		_tmp24_ = self->priv->_window_actor;
#line 345 "../plugins/pip/PopupWindow.vala"
		if (!meta_window_actor_is_destroyed (_tmp24_)) {
#line 346 "../plugins/pip/PopupWindow.vala"
			clutter_actor_show ((ClutterActor*) self);
#line 1149 "PopupWindow.c"
		}
	}
#line 349 "../plugins/pip/PopupWindow.vala"
	_tmp25_ = focus_window;
#line 349 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_previous_focus = _tmp25_;
#line 1156 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_size (GalaPluginsPIPPopupWindow* self)
{
	gint clone_container_width = 0;
	gint clone_container_height = 0;
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ClutterActor* _tmp24_;
	ClutterActor* _tmp25_;
#line 352 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 355 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 355 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 355 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 355 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1179 "PopupWindow.c"
		gfloat src_width = 0.0F;
		gfloat src_height = 0.0F;
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
		ClutterActor* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		ClutterActor* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 356 "../plugins/pip/PopupWindow.vala"
		src_width = 0.0f;
#line 356 "../plugins/pip/PopupWindow.vala"
		src_height = 0.0f;
#line 357 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 357 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, NULL, NULL, &_tmp4_, &_tmp5_);
#line 357 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp4_;
#line 357 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp5_;
#line 358 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone_container;
#line 358 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp6_, "scale-x", &_tmp7_, NULL);
#line 358 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 358 "../plugins/pip/PopupWindow.vala"
		clone_container_width = (gint) (src_width * _tmp8_);
#line 359 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = self->priv->clone_container;
#line 359 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp9_, "scale-y", &_tmp10_, NULL);
#line 359 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = _tmp10_;
#line 359 "../plugins/pip/PopupWindow.vala"
		clone_container_height = (gint) (src_height * _tmp11_);
#line 1219 "PopupWindow.c"
	} else {
		ClutterActor* _tmp12_;
		gfloat _tmp13_;
		gfloat _tmp14_;
		ClutterActor* _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		ClutterActor* _tmp18_;
		gfloat _tmp19_;
		gfloat _tmp20_;
		ClutterActor* _tmp21_;
		gdouble _tmp22_;
		gdouble _tmp23_;
#line 361 "../plugins/pip/PopupWindow.vala"
		_tmp12_ = self->priv->clone_container;
#line 361 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = clutter_actor_get_width (_tmp12_);
#line 361 "../plugins/pip/PopupWindow.vala"
		_tmp14_ = _tmp13_;
#line 361 "../plugins/pip/PopupWindow.vala"
		_tmp15_ = self->priv->clone_container;
#line 361 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp15_, "scale-x", &_tmp16_, NULL);
#line 361 "../plugins/pip/PopupWindow.vala"
		_tmp17_ = _tmp16_;
#line 361 "../plugins/pip/PopupWindow.vala"
		clone_container_width = (gint) (_tmp14_ * _tmp17_);
#line 362 "../plugins/pip/PopupWindow.vala"
		_tmp18_ = self->priv->clone_container;
#line 362 "../plugins/pip/PopupWindow.vala"
		_tmp19_ = clutter_actor_get_height (_tmp18_);
#line 362 "../plugins/pip/PopupWindow.vala"
		_tmp20_ = _tmp19_;
#line 362 "../plugins/pip/PopupWindow.vala"
		_tmp21_ = self->priv->clone_container;
#line 362 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp21_, "scale-y", &_tmp22_, NULL);
#line 362 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = _tmp22_;
#line 362 "../plugins/pip/PopupWindow.vala"
		clone_container_height = (gint) (_tmp20_ * _tmp23_);
#line 1261 "PopupWindow.c"
	}
#line 365 "../plugins/pip/PopupWindow.vala"
	_tmp24_ = self->priv->container;
#line 365 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_width (_tmp24_, (gfloat) clone_container_width);
#line 366 "../plugins/pip/PopupWindow.vala"
	_tmp25_ = self->priv->container;
#line 366 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_height (_tmp25_, (gfloat) clone_container_height);
#line 368 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_width ((ClutterActor*) self, (gfloat) (clone_container_width + self->priv->button_size));
#line 369 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_height ((ClutterActor*) self, (gfloat) (clone_container_height + self->priv->button_size));
#line 1275 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_clone_clip (GalaPluginsPIPPopupWindow* self)
{
	MtkRectangle rect = {0};
	MetaWindowActor* _tmp0_;
	MetaWindow* _tmp1_;
	MtkRectangle _tmp2_ = {0};
	gfloat x_offset = 0.0F;
	MtkRectangle _tmp3_;
	MetaWindowActor* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat y_offset = 0.0F;
	MtkRectangle _tmp7_;
	MetaWindowActor* _tmp8_;
	gfloat _tmp9_;
	gfloat _tmp10_;
	ClutterClone* _tmp11_;
	MtkRectangle _tmp12_;
	MtkRectangle _tmp13_;
	ClutterClone* _tmp14_;
	ClutterActor* _tmp15_;
	MtkRectangle _tmp16_;
	MtkRectangle _tmp17_;
#line 375 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 376 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_window_actor;
#line 376 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_tmp0_);
#line 376 "../plugins/pip/PopupWindow.vala"
	meta_window_get_frame_rect (_tmp1_, &_tmp2_);
#line 376 "../plugins/pip/PopupWindow.vala"
	rect = _tmp2_;
#line 378 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = rect;
#line 378 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->_window_actor;
#line 378 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_x ((ClutterActor*) _tmp4_);
#line 378 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 378 "../plugins/pip/PopupWindow.vala"
	x_offset = _tmp3_.x - _tmp6_;
#line 379 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = rect;
#line 379 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->_window_actor;
#line 379 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = clutter_actor_get_y ((ClutterActor*) _tmp8_);
#line 379 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = _tmp9_;
#line 379 "../plugins/pip/PopupWindow.vala"
	y_offset = _tmp7_.y - _tmp10_;
#line 380 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->clone;
#line 380 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = rect;
#line 380 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = rect;
#line 380 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_clip ((ClutterActor*) _tmp11_, x_offset, y_offset, (gfloat) _tmp12_.width, (gfloat) _tmp13_.height);
#line 381 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = self->priv->clone;
#line 381 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position ((ClutterActor*) _tmp14_, -x_offset, -y_offset);
#line 383 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = self->priv->clone_container;
#line 383 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = rect;
#line 383 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = rect;
#line 383 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_size (_tmp15_, (gfloat) _tmp16_.width, (gfloat) _tmp17_.height);
#line 1352 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_clone_container_scale (GalaPluginsPIPPopupWindow* self)
{
	gfloat src_width = 0.0F;
	gfloat src_height = 0.0F;
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gfloat max_width = 0.0F;
	gfloat _tmp12_;
	gfloat _tmp13_;
	gfloat max_height = 0.0F;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat new_width = 0.0F;
	gfloat new_height = 0.0F;
	gfloat _tmp16_ = 0.0F;
	gfloat _tmp17_ = 0.0F;
	gfloat window_width = 0.0F;
	gfloat window_height = 0.0F;
	gfloat _tmp18_ = 0.0F;
	gfloat _tmp19_ = 0.0F;
	gfloat new_scale_x = 0.0F;
	gfloat new_scale_y = 0.0F;
	ClutterActor* _tmp20_;
	ClutterActor* _tmp21_;
#line 386 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 387 "../plugins/pip/PopupWindow.vala"
	src_width = 1.0f;
#line 387 "../plugins/pip/PopupWindow.vala"
	src_height = 1.0f;
#line 388 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 388 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 388 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 388 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1395 "PopupWindow.c"
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
#line 389 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 389 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, NULL, NULL, &_tmp4_, &_tmp5_);
#line 389 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp4_;
#line 389 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp5_;
#line 1407 "PopupWindow.c"
	} else {
		ClutterActor* _tmp6_;
		gfloat _tmp7_;
		gfloat _tmp8_;
		ClutterActor* _tmp9_;
		gfloat _tmp10_;
		gfloat _tmp11_;
#line 391 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone_container;
#line 391 "../plugins/pip/PopupWindow.vala"
		_tmp7_ = clutter_actor_get_width (_tmp6_);
#line 391 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 391 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp8_;
#line 392 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = self->priv->clone_container;
#line 392 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = clutter_actor_get_height (_tmp9_);
#line 392 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = _tmp10_;
#line 392 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp11_;
#line 1431 "PopupWindow.c"
	}
#line 395 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = clutter_actor_get_width ((ClutterActor*) self);
#line 395 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = _tmp12_;
#line 395 "../plugins/pip/PopupWindow.vala"
	max_width = _tmp13_ - self->priv->button_size;
#line 396 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = clutter_actor_get_height ((ClutterActor*) self);
#line 396 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = _tmp14_;
#line 396 "../plugins/pip/PopupWindow.vala"
	max_height = _tmp15_ - self->priv->button_size;
#line 399 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (src_width, src_height, max_width, max_height, &_tmp16_, &_tmp17_);
#line 399 "../plugins/pip/PopupWindow.vala"
	new_width = _tmp16_;
#line 399 "../plugins/pip/PopupWindow.vala"
	new_height = _tmp17_;
#line 405 "../plugins/pip/PopupWindow.vala"
	window_width = 1.0f;
#line 405 "../plugins/pip/PopupWindow.vala"
	window_height = 1.0f;
#line 406 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_target_window_size (self, &_tmp18_, &_tmp19_);
#line 406 "../plugins/pip/PopupWindow.vala"
	window_width = _tmp18_;
#line 406 "../plugins/pip/PopupWindow.vala"
	window_height = _tmp19_;
#line 408 "../plugins/pip/PopupWindow.vala"
	new_scale_x = new_width / window_width;
#line 409 "../plugins/pip/PopupWindow.vala"
	new_scale_y = new_height / window_height;
#line 411 "../plugins/pip/PopupWindow.vala"
	_tmp20_ = self->priv->clone_container;
#line 411 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp20_, "scale-x", (gdouble) CLAMP (new_scale_x, GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE, GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE), NULL);
#line 412 "../plugins/pip/PopupWindow.vala"
	_tmp21_ = self->priv->clone_container;
#line 412 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp21_, "scale-y", (gdouble) CLAMP (new_scale_y, GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE, GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE), NULL);
#line 414 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_container_position (self);
#line 1475 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_clone_container_position (GalaPluginsPIPPopupWindow* self)
{
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 417 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 418 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 418 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 418 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 418 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 1494 "PopupWindow.c"
		gfloat clip_x = 0.0F;
		gfloat clip_y = 0.0F;
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
		ClutterActor* _tmp6_;
		ClutterActor* _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
		ClutterActor* _tmp10_;
		ClutterActor* _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
#line 419 "../plugins/pip/PopupWindow.vala"
		clip_x = 0.0f;
#line 419 "../plugins/pip/PopupWindow.vala"
		clip_y = 0.0f;
#line 420 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 420 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, &_tmp4_, &_tmp5_, NULL, NULL);
#line 420 "../plugins/pip/PopupWindow.vala"
		clip_x = _tmp4_;
#line 420 "../plugins/pip/PopupWindow.vala"
		clip_y = _tmp5_;
#line 421 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone_container;
#line 421 "../plugins/pip/PopupWindow.vala"
		_tmp7_ = self->priv->clone_container;
#line 421 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp7_, "scale-x", &_tmp8_, NULL);
#line 421 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = _tmp8_;
#line 421 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x (_tmp6_, (gfloat) ((-clip_x) * _tmp9_));
#line 422 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = self->priv->clone_container;
#line 422 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = self->priv->clone_container;
#line 422 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp11_, "scale-y", &_tmp12_, NULL);
#line 422 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = _tmp12_;
#line 422 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y (_tmp10_, (gfloat) ((-clip_y) * _tmp13_));
#line 1540 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_update_screen_position (GalaPluginsPIPPopupWindow* self)
{
#line 426 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 427 "../plugins/pip/PopupWindow.vala"
	if (!gala_plugins_pip_popup_window_place_window_off_screen (self)) {
#line 428 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_place_window_in_screen (self);
#line 1553 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_place_window_in_screen (GalaPluginsPIPPopupWindow* self)
{
	MtkRectangle monitor_rect = {0};
	MtkRectangle _tmp0_ = {0};
	gint monitor_x = 0;
	MtkRectangle _tmp1_;
	gint monitor_y = 0;
	MtkRectangle _tmp2_;
	gint monitor_width = 0;
	MtkRectangle _tmp3_;
	gint monitor_height = 0;
	MtkRectangle _tmp4_;
	gint screen_limit_start_x = 0;
	gfloat screen_limit_end_x = 0.0F;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gint screen_limit_start_y = 0;
	gfloat screen_limit_end_y = 0.0F;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gint _tmp9_ = 0;
	GalaWindowManager* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gint duration = 0;
	gfloat _tmp13_;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat _tmp16_;
#line 432 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 433 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 440 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_current_monitor_rect (self, &_tmp0_);
#line 440 "../plugins/pip/PopupWindow.vala"
	monitor_rect = _tmp0_;
#line 442 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = monitor_rect;
#line 442 "../plugins/pip/PopupWindow.vala"
	monitor_x = _tmp1_.x;
#line 443 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = monitor_rect;
#line 443 "../plugins/pip/PopupWindow.vala"
	monitor_y = _tmp2_.y;
#line 444 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = monitor_rect;
#line 444 "../plugins/pip/PopupWindow.vala"
	monitor_width = _tmp3_.width;
#line 445 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = monitor_rect;
#line 445 "../plugins/pip/PopupWindow.vala"
	monitor_height = _tmp4_.height;
#line 447 "../plugins/pip/PopupWindow.vala"
	screen_limit_start_x = GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN + monitor_x;
#line 448 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_width ((ClutterActor*) self);
#line 448 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 448 "../plugins/pip/PopupWindow.vala"
	screen_limit_end_x = ((monitor_width + monitor_x) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp6_;
#line 449 "../plugins/pip/PopupWindow.vala"
	screen_limit_start_y = GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN + monitor_y;
#line 450 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = clutter_actor_get_height ((ClutterActor*) self);
#line 450 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = _tmp7_;
#line 450 "../plugins/pip/PopupWindow.vala"
	screen_limit_end_y = ((monitor_height + monitor_y) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp8_;
#line 452 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = self->priv->_wm;
#line 452 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = gala_window_manager_get_enable_animations (_tmp10_);
#line 452 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = _tmp11_;
#line 452 "../plugins/pip/PopupWindow.vala"
	if (_tmp12_) {
#line 452 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = 300;
#line 1637 "PopupWindow.c"
	} else {
#line 452 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = 0;
#line 1641 "PopupWindow.c"
	}
#line 452 "../plugins/pip/PopupWindow.vala"
	duration = _tmp9_;
#line 454 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 455 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_OUT_BACK);
#line 456 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) duration);
#line 457 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = clutter_actor_get_x ((ClutterActor*) self);
#line 457 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = _tmp13_;
#line 457 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_x ((ClutterActor*) self, CLAMP (_tmp14_, (gfloat) screen_limit_start_x, screen_limit_end_x));
#line 458 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = clutter_actor_get_y ((ClutterActor*) self);
#line 458 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = _tmp15_;
#line 458 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_y ((ClutterActor*) self, CLAMP (_tmp16_, (gfloat) screen_limit_start_y, screen_limit_end_y));
#line 459 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 1665 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_place_window_off_screen (GalaPluginsPIPPopupWindow* self)
{
	gint _tmp0_ = 0;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint duration = 0;
	MtkRectangle monitor_rect = {0};
	MtkRectangle _tmp4_ = {0};
	gint monitor_x = 0;
	MtkRectangle _tmp5_;
	gint monitor_y = 0;
	MtkRectangle _tmp6_;
	gint monitor_width = 0;
	MtkRectangle _tmp7_;
	gint monitor_height = 0;
	MtkRectangle _tmp8_;
	gfloat off_screen_x_threshold = 0.0F;
	gfloat _tmp9_;
	gfloat _tmp10_;
	gboolean off_screen_x = FALSE;
	gfloat _tmp11_;
	gfloat _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean off_screen_w = FALSE;
	gfloat _tmp18_;
	gfloat _tmp19_;
	gfloat _tmp20_;
	gfloat _tmp21_;
	gboolean _tmp22_ = FALSE;
	gfloat off_screen_y_threshold = 0.0F;
	gfloat _tmp27_;
	gfloat _tmp28_;
	gboolean off_screen_y = FALSE;
	gfloat _tmp29_;
	gfloat _tmp30_;
	gboolean _tmp31_ = FALSE;
	gboolean off_screen_h = FALSE;
	gfloat _tmp36_;
	gfloat _tmp37_;
	gfloat _tmp38_;
	gfloat _tmp39_;
	gboolean _tmp40_ = FALSE;
	gboolean result;
#line 462 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 463 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 465 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 465 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 465 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 465 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 465 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 300;
#line 1727 "PopupWindow.c"
	} else {
#line 465 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 0;
#line 1731 "PopupWindow.c"
	}
#line 465 "../plugins/pip/PopupWindow.vala"
	duration = _tmp0_;
#line 467 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 468 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_OUT_BACK);
#line 469 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) duration);
#line 476 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_current_monitor_rect (self, &_tmp4_);
#line 476 "../plugins/pip/PopupWindow.vala"
	monitor_rect = _tmp4_;
#line 478 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = monitor_rect;
#line 478 "../plugins/pip/PopupWindow.vala"
	monitor_x = _tmp5_.x;
#line 479 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = monitor_rect;
#line 479 "../plugins/pip/PopupWindow.vala"
	monitor_y = _tmp6_.y;
#line 480 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = monitor_rect;
#line 480 "../plugins/pip/PopupWindow.vala"
	monitor_width = _tmp7_.width;
#line 481 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = monitor_rect;
#line 481 "../plugins/pip/PopupWindow.vala"
	monitor_height = _tmp8_.height;
#line 484 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = clutter_actor_get_width ((ClutterActor*) self);
#line 484 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = _tmp9_;
#line 484 "../plugins/pip/PopupWindow.vala"
	off_screen_x_threshold = _tmp10_ * GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT;
#line 486 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = clutter_actor_get_x ((ClutterActor*) self);
#line 486 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = _tmp11_;
#line 486 "../plugins/pip/PopupWindow.vala"
	off_screen_x = (_tmp12_ - monitor_x) < (-off_screen_x_threshold);
#line 487 "../plugins/pip/PopupWindow.vala"
	if (off_screen_x) {
#line 1775 "PopupWindow.c"
		gfloat _tmp14_;
		gfloat _tmp15_;
#line 488 "../plugins/pip/PopupWindow.vala"
		_tmp14_ = clutter_actor_get_x ((ClutterActor*) self);
#line 488 "../plugins/pip/PopupWindow.vala"
		_tmp15_ = _tmp14_;
#line 488 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp15_, CLUTTER_ORIENTATION_HORIZONTAL);
#line 1784 "PopupWindow.c"
	} else {
#line 487 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = FALSE;
#line 1788 "PopupWindow.c"
	}
#line 487 "../plugins/pip/PopupWindow.vala"
	if (_tmp13_) {
#line 1792 "PopupWindow.c"
		gfloat _tmp16_;
		gfloat _tmp17_;
#line 489 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 490 "../plugins/pip/PopupWindow.vala"
		_tmp16_ = clutter_actor_get_width ((ClutterActor*) self);
#line 490 "../plugins/pip/PopupWindow.vala"
		_tmp17_ = _tmp16_;
#line 490 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x ((ClutterActor*) self, (monitor_x - _tmp17_) + GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS);
#line 1803 "PopupWindow.c"
	}
#line 493 "../plugins/pip/PopupWindow.vala"
	_tmp18_ = clutter_actor_get_x ((ClutterActor*) self);
#line 493 "../plugins/pip/PopupWindow.vala"
	_tmp19_ = _tmp18_;
#line 493 "../plugins/pip/PopupWindow.vala"
	_tmp20_ = clutter_actor_get_width ((ClutterActor*) self);
#line 493 "../plugins/pip/PopupWindow.vala"
	_tmp21_ = _tmp20_;
#line 493 "../plugins/pip/PopupWindow.vala"
	off_screen_w = (_tmp19_ + _tmp21_) > ((monitor_x + monitor_width) + off_screen_x_threshold);
#line 494 "../plugins/pip/PopupWindow.vala"
	if (off_screen_w) {
#line 1817 "PopupWindow.c"
		gfloat _tmp23_;
		gfloat _tmp24_;
		gfloat _tmp25_;
		gfloat _tmp26_;
#line 495 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = clutter_actor_get_x ((ClutterActor*) self);
#line 495 "../plugins/pip/PopupWindow.vala"
		_tmp24_ = _tmp23_;
#line 495 "../plugins/pip/PopupWindow.vala"
		_tmp25_ = clutter_actor_get_width ((ClutterActor*) self);
#line 495 "../plugins/pip/PopupWindow.vala"
		_tmp26_ = _tmp25_;
#line 495 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp24_ + _tmp26_, CLUTTER_ORIENTATION_HORIZONTAL);
#line 1832 "PopupWindow.c"
	} else {
#line 494 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = FALSE;
#line 1836 "PopupWindow.c"
	}
#line 494 "../plugins/pip/PopupWindow.vala"
	if (_tmp22_) {
#line 496 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 497 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x ((ClutterActor*) self, (gfloat) ((monitor_x + monitor_width) - GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS));
#line 1844 "PopupWindow.c"
	}
#line 501 "../plugins/pip/PopupWindow.vala"
	_tmp27_ = clutter_actor_get_height ((ClutterActor*) self);
#line 501 "../plugins/pip/PopupWindow.vala"
	_tmp28_ = _tmp27_;
#line 501 "../plugins/pip/PopupWindow.vala"
	off_screen_y_threshold = _tmp28_ * GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT;
#line 503 "../plugins/pip/PopupWindow.vala"
	_tmp29_ = clutter_actor_get_y ((ClutterActor*) self);
#line 503 "../plugins/pip/PopupWindow.vala"
	_tmp30_ = _tmp29_;
#line 503 "../plugins/pip/PopupWindow.vala"
	off_screen_y = (_tmp30_ - monitor_y) < (-off_screen_y_threshold);
#line 504 "../plugins/pip/PopupWindow.vala"
	if (off_screen_y) {
#line 1860 "PopupWindow.c"
		gfloat _tmp32_;
		gfloat _tmp33_;
#line 505 "../plugins/pip/PopupWindow.vala"
		_tmp32_ = clutter_actor_get_y ((ClutterActor*) self);
#line 505 "../plugins/pip/PopupWindow.vala"
		_tmp33_ = _tmp32_;
#line 505 "../plugins/pip/PopupWindow.vala"
		_tmp31_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp33_, CLUTTER_ORIENTATION_VERTICAL);
#line 1869 "PopupWindow.c"
	} else {
#line 504 "../plugins/pip/PopupWindow.vala"
		_tmp31_ = FALSE;
#line 1873 "PopupWindow.c"
	}
#line 504 "../plugins/pip/PopupWindow.vala"
	if (_tmp31_) {
#line 1877 "PopupWindow.c"
		gfloat _tmp34_;
		gfloat _tmp35_;
#line 506 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 507 "../plugins/pip/PopupWindow.vala"
		_tmp34_ = clutter_actor_get_height ((ClutterActor*) self);
#line 507 "../plugins/pip/PopupWindow.vala"
		_tmp35_ = _tmp34_;
#line 507 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y ((ClutterActor*) self, (monitor_y - _tmp35_) + GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS);
#line 1888 "PopupWindow.c"
	}
#line 510 "../plugins/pip/PopupWindow.vala"
	_tmp36_ = clutter_actor_get_y ((ClutterActor*) self);
#line 510 "../plugins/pip/PopupWindow.vala"
	_tmp37_ = _tmp36_;
#line 510 "../plugins/pip/PopupWindow.vala"
	_tmp38_ = clutter_actor_get_height ((ClutterActor*) self);
#line 510 "../plugins/pip/PopupWindow.vala"
	_tmp39_ = _tmp38_;
#line 510 "../plugins/pip/PopupWindow.vala"
	off_screen_h = (_tmp37_ + _tmp39_) > ((monitor_y + monitor_height) + off_screen_y_threshold);
#line 511 "../plugins/pip/PopupWindow.vala"
	if (off_screen_h) {
#line 1902 "PopupWindow.c"
		gfloat _tmp41_;
		gfloat _tmp42_;
		gfloat _tmp43_;
		gfloat _tmp44_;
#line 512 "../plugins/pip/PopupWindow.vala"
		_tmp41_ = clutter_actor_get_y ((ClutterActor*) self);
#line 512 "../plugins/pip/PopupWindow.vala"
		_tmp42_ = _tmp41_;
#line 512 "../plugins/pip/PopupWindow.vala"
		_tmp43_ = clutter_actor_get_height ((ClutterActor*) self);
#line 512 "../plugins/pip/PopupWindow.vala"
		_tmp44_ = _tmp43_;
#line 512 "../plugins/pip/PopupWindow.vala"
		_tmp40_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp42_ + _tmp44_, CLUTTER_ORIENTATION_VERTICAL);
#line 1917 "PopupWindow.c"
	} else {
#line 511 "../plugins/pip/PopupWindow.vala"
		_tmp40_ = FALSE;
#line 1921 "PopupWindow.c"
	}
#line 511 "../plugins/pip/PopupWindow.vala"
	if (_tmp40_) {
#line 513 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 514 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y ((ClutterActor*) self, (gfloat) ((monitor_y + monitor_height) - GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS));
#line 1929 "PopupWindow.c"
	}
#line 517 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 519 "../plugins/pip/PopupWindow.vala"
	result = self->priv->off_screen;
#line 519 "../plugins/pip/PopupWindow.vala"
	return result;
#line 1937 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_coord_is_in_other_monitor (GalaPluginsPIPPopupWindow* self,
                                                         gfloat coord,
                                                         ClutterOrientation axis)
{
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaDisplay* _tmp2_;
	gint n_monitors = 0;
	MetaDisplay* _tmp3_;
	gint current = 0;
	MetaDisplay* _tmp4_;
	gboolean result;
#line 522 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 523 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 523 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 523 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 523 "../plugins/pip/PopupWindow.vala"
	display = _tmp2_;
#line 524 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = display;
#line 524 "../plugins/pip/PopupWindow.vala"
	n_monitors = meta_display_get_n_monitors (_tmp3_);
#line 526 "../plugins/pip/PopupWindow.vala"
	if (n_monitors == 1) {
#line 527 "../plugins/pip/PopupWindow.vala"
		result = FALSE;
#line 527 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (display);
#line 527 "../plugins/pip/PopupWindow.vala"
		return result;
#line 1976 "PopupWindow.c"
	}
#line 530 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = display;
#line 530 "../plugins/pip/PopupWindow.vala"
	current = meta_display_get_current_monitor (_tmp4_);
#line 1982 "PopupWindow.c"
	{
		gint i = 0;
#line 531 "../plugins/pip/PopupWindow.vala"
		i = 0;
#line 1987 "PopupWindow.c"
		{
			gboolean _tmp5_ = FALSE;
#line 531 "../plugins/pip/PopupWindow.vala"
			_tmp5_ = TRUE;
#line 531 "../plugins/pip/PopupWindow.vala"
			while (TRUE) {
#line 531 "../plugins/pip/PopupWindow.vala"
				if (!_tmp5_) {
#line 1996 "PopupWindow.c"
					gint _tmp6_;
#line 531 "../plugins/pip/PopupWindow.vala"
					_tmp6_ = i;
#line 531 "../plugins/pip/PopupWindow.vala"
					i = _tmp6_ + 1;
#line 2002 "PopupWindow.c"
				}
#line 531 "../plugins/pip/PopupWindow.vala"
				_tmp5_ = FALSE;
#line 531 "../plugins/pip/PopupWindow.vala"
				if (!(i < n_monitors)) {
#line 531 "../plugins/pip/PopupWindow.vala"
					break;
#line 2010 "PopupWindow.c"
				}
#line 532 "../plugins/pip/PopupWindow.vala"
				if (i != current) {
#line 2014 "PopupWindow.c"
					MtkRectangle monitor_rect = {0};
					MetaDisplay* _tmp7_;
					MtkRectangle _tmp8_ = {0};
					gboolean in_monitor = FALSE;
#line 533 "../plugins/pip/PopupWindow.vala"
					_tmp7_ = display;
#line 533 "../plugins/pip/PopupWindow.vala"
					meta_display_get_monitor_geometry (_tmp7_, i, &_tmp8_);
#line 533 "../plugins/pip/PopupWindow.vala"
					monitor_rect = _tmp8_;
#line 534 "../plugins/pip/PopupWindow.vala"
					in_monitor = FALSE;
#line 536 "../plugins/pip/PopupWindow.vala"
					if (axis == CLUTTER_ORIENTATION_HORIZONTAL) {
#line 2029 "PopupWindow.c"
						gboolean _tmp9_ = FALSE;
						MtkRectangle _tmp10_;
#line 537 "../plugins/pip/PopupWindow.vala"
						_tmp10_ = monitor_rect;
#line 537 "../plugins/pip/PopupWindow.vala"
						if (coord >= ((gfloat) _tmp10_.x)) {
#line 2036 "PopupWindow.c"
							MtkRectangle _tmp11_;
							MtkRectangle _tmp12_;
#line 537 "../plugins/pip/PopupWindow.vala"
							_tmp11_ = monitor_rect;
#line 537 "../plugins/pip/PopupWindow.vala"
							_tmp12_ = monitor_rect;
#line 537 "../plugins/pip/PopupWindow.vala"
							_tmp9_ = coord <= ((gfloat) (_tmp11_.x + _tmp12_.width));
#line 2045 "PopupWindow.c"
						} else {
#line 537 "../plugins/pip/PopupWindow.vala"
							_tmp9_ = FALSE;
#line 2049 "PopupWindow.c"
						}
#line 537 "../plugins/pip/PopupWindow.vala"
						in_monitor = _tmp9_;
#line 2053 "PopupWindow.c"
					} else {
						gboolean _tmp13_ = FALSE;
						MtkRectangle _tmp14_;
#line 539 "../plugins/pip/PopupWindow.vala"
						_tmp14_ = monitor_rect;
#line 539 "../plugins/pip/PopupWindow.vala"
						if (coord >= ((gfloat) _tmp14_.y)) {
#line 2061 "PopupWindow.c"
							MtkRectangle _tmp15_;
							MtkRectangle _tmp16_;
#line 539 "../plugins/pip/PopupWindow.vala"
							_tmp15_ = monitor_rect;
#line 539 "../plugins/pip/PopupWindow.vala"
							_tmp16_ = monitor_rect;
#line 539 "../plugins/pip/PopupWindow.vala"
							_tmp13_ = coord <= ((gfloat) (_tmp15_.y + _tmp16_.height));
#line 2070 "PopupWindow.c"
						} else {
#line 539 "../plugins/pip/PopupWindow.vala"
							_tmp13_ = FALSE;
#line 2074 "PopupWindow.c"
						}
#line 539 "../plugins/pip/PopupWindow.vala"
						in_monitor = _tmp13_;
#line 2078 "PopupWindow.c"
					}
#line 542 "../plugins/pip/PopupWindow.vala"
					if (in_monitor) {
#line 543 "../plugins/pip/PopupWindow.vala"
						result = TRUE;
#line 543 "../plugins/pip/PopupWindow.vala"
						_g_object_unref0 (display);
#line 543 "../plugins/pip/PopupWindow.vala"
						return result;
#line 2088 "PopupWindow.c"
					}
				}
			}
		}
	}
#line 548 "../plugins/pip/PopupWindow.vala"
	result = FALSE;
#line 548 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (display);
#line 548 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2100 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_get_current_monitor_rect (GalaPluginsPIPPopupWindow* self,
                                                        MtkRectangle* rect)
{
	MtkRectangle _vala_rect = {0};
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaDisplay* _tmp2_;
	MtkRectangle _tmp3_ = {0};
#line 552 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 556 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 556 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 556 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 556 "../plugins/pip/PopupWindow.vala"
	display = _tmp2_;
#line 557 "../plugins/pip/PopupWindow.vala"
	meta_display_get_monitor_geometry (display, meta_display_get_current_monitor (display), &_tmp3_);
#line 557 "../plugins/pip/PopupWindow.vala"
	_vala_rect = _tmp3_;
#line 552 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (display);
#line 552 "../plugins/pip/PopupWindow.vala"
	if (rect) {
#line 552 "../plugins/pip/PopupWindow.vala"
		*rect = _vala_rect;
#line 2133 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_get_target_window_size (GalaPluginsPIPPopupWindow* self,
                                                      gfloat* width,
                                                      gfloat* height)
{
	gfloat _vala_width = 0.0F;
	gfloat _vala_height = 0.0F;
	ClutterActor* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 560 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 561 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->clone_container;
#line 561 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp0_, "has-clip", &_tmp1_, NULL);
#line 561 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _tmp1_;
#line 561 "../plugins/pip/PopupWindow.vala"
	if (_tmp2_) {
#line 2157 "PopupWindow.c"
		ClutterActor* _tmp3_;
		gfloat _tmp4_ = 0.0F;
		gfloat _tmp5_ = 0.0F;
#line 562 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone_container;
#line 562 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp3_, NULL, NULL, &_tmp4_, &_tmp5_);
#line 562 "../plugins/pip/PopupWindow.vala"
		_vala_width = _tmp4_;
#line 562 "../plugins/pip/PopupWindow.vala"
		_vala_height = _tmp5_;
#line 2169 "PopupWindow.c"
	} else {
		ClutterClone* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 563 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->clone;
#line 563 "../plugins/pip/PopupWindow.vala"
		g_object_get ((ClutterActor*) _tmp6_, "has-clip", &_tmp7_, NULL);
#line 563 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 563 "../plugins/pip/PopupWindow.vala"
		if (_tmp8_) {
#line 2182 "PopupWindow.c"
			ClutterClone* _tmp9_;
			gfloat _tmp10_ = 0.0F;
			gfloat _tmp11_ = 0.0F;
#line 564 "../plugins/pip/PopupWindow.vala"
			_tmp9_ = self->priv->clone;
#line 564 "../plugins/pip/PopupWindow.vala"
			clutter_actor_get_clip ((ClutterActor*) _tmp9_, NULL, NULL, &_tmp10_, &_tmp11_);
#line 564 "../plugins/pip/PopupWindow.vala"
			_vala_width = _tmp10_;
#line 564 "../plugins/pip/PopupWindow.vala"
			_vala_height = _tmp11_;
#line 2194 "PopupWindow.c"
		} else {
			ClutterClone* _tmp12_;
			gfloat _tmp13_;
			gfloat _tmp14_;
			ClutterClone* _tmp15_;
			gfloat _tmp16_;
			gfloat _tmp17_;
#line 566 "../plugins/pip/PopupWindow.vala"
			_tmp12_ = self->priv->clone;
#line 566 "../plugins/pip/PopupWindow.vala"
			_tmp13_ = clutter_actor_get_width ((ClutterActor*) _tmp12_);
#line 566 "../plugins/pip/PopupWindow.vala"
			_tmp14_ = _tmp13_;
#line 566 "../plugins/pip/PopupWindow.vala"
			_vala_width = _tmp14_;
#line 567 "../plugins/pip/PopupWindow.vala"
			_tmp15_ = self->priv->clone;
#line 567 "../plugins/pip/PopupWindow.vala"
			_tmp16_ = clutter_actor_get_height ((ClutterActor*) _tmp15_);
#line 567 "../plugins/pip/PopupWindow.vala"
			_tmp17_ = _tmp16_;
#line 567 "../plugins/pip/PopupWindow.vala"
			_vala_height = _tmp17_;
#line 2218 "PopupWindow.c"
		}
	}
#line 560 "../plugins/pip/PopupWindow.vala"
	if (width) {
#line 560 "../plugins/pip/PopupWindow.vala"
		*width = _vala_width;
#line 2225 "PopupWindow.c"
	}
#line 560 "../plugins/pip/PopupWindow.vala"
	if (height) {
#line 560 "../plugins/pip/PopupWindow.vala"
		*height = _vala_height;
#line 2231 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_activate (GalaPluginsPIPPopupWindow* self)
{
#line 571 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 572 "../plugins/pip/PopupWindow.vala"
	if (self->priv->off_screen) {
#line 573 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_place_window_in_screen (self);
#line 2244 "PopupWindow.c"
	} else {
		MetaWindow* window = NULL;
		MetaWindowActor* _tmp0_;
		MetaWindow* _tmp1_;
		MetaWindow* _tmp2_;
		MetaWindow* _tmp3_;
#line 575 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = self->priv->_window_actor;
#line 575 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = meta_window_actor_get_meta_window (_tmp0_);
#line 575 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 575 "../plugins/pip/PopupWindow.vala"
		window = _tmp2_;
#line 576 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = window;
#line 576 "../plugins/pip/PopupWindow.vala"
		meta_window_activate (_tmp3_, clutter_get_current_event_time ());
#line 572 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (window);
#line 2265 "PopupWindow.c"
	}
}

GalaWindowManager*
gala_plugins_pip_popup_window_get_wm (GalaPluginsPIPPopupWindow* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 19 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2282 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_set_wm (GalaPluginsPIPPopupWindow* self,
                                      GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 19 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 19 "../plugins/pip/PopupWindow.vala"
	old_value = gala_plugins_pip_popup_window_get_wm (self);
#line 19 "../plugins/pip/PopupWindow.vala"
	if (old_value != value) {
#line 2296 "PopupWindow.c"
		GalaWindowManager* _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->_wm);
#line 19 "../plugins/pip/PopupWindow.vala"
		self->priv->_wm = _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY]);
#line 2306 "PopupWindow.c"
	}
}

MetaWindowActor*
gala_plugins_pip_popup_window_get_window_actor (GalaPluginsPIPPopupWindow* self)
{
	MetaWindowActor* result;
	MetaWindowActor* _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_window_actor;
#line 20 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2323 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_set_window_actor (GalaPluginsPIPPopupWindow* self,
                                                MetaWindowActor* value)
{
	MetaWindowActor* old_value;
#line 20 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 20 "../plugins/pip/PopupWindow.vala"
	old_value = gala_plugins_pip_popup_window_get_window_actor (self);
#line 20 "../plugins/pip/PopupWindow.vala"
	if (old_value != value) {
#line 2337 "PopupWindow.c"
		MetaWindowActor* _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 20 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->_window_actor);
#line 20 "../plugins/pip/PopupWindow.vala"
		self->priv->_window_actor = _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY]);
#line 2347 "PopupWindow.c"
	}
}

static ClutterActor*
_gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin (GalaDragDropAction* _sender,
                                                                               gfloat x,
                                                                               gfloat y,
                                                                               gpointer self)
{
	ClutterActor* result;
	result = gala_plugins_pip_popup_window_on_move_begin ((GalaPluginsPIPPopupWindow*) self);
#line 73 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2361 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled (GalaDragDropAction* _sender,
                                                                                gpointer self)
{
#line 74 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_move_end ((GalaPluginsPIPPopupWindow*) self);
#line 2370 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked (GalaDragDropAction* _sender,
                                                                             guint32 button,
                                                                             gpointer self)
{
#line 75 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_activate ((GalaPluginsPIPPopupWindow*) self);
#line 2380 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered (GalaCloseButton* _sender,
                                                                                   guint32 timestamp,
                                                                                   gpointer self)
{
#line 115 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_close_click_clicked ((GalaPluginsPIPPopupWindow*) self);
#line 2390 "PopupWindow.c"
}

static gboolean
_gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                        ClutterEvent* event,
                                                                                        gpointer self)
{
	gboolean result;
	result = gala_plugins_pip_popup_window_on_resize_button_press ((GalaPluginsPIPPopupWindow*) self, event);
#line 122 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2402 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self)
{
#line 128 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_allocation_changed ((GalaPluginsPIPPopupWindow*) self);
#line 2412 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged (MetaWindow* _sender,
                                                                             gpointer self)
{
#line 133 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_close_click_clicked ((GalaPluginsPIPPopupWindow*) self);
#line 2421 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_update_window_focus_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self)
{
#line 134 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_window_focus ((GalaPluginsPIPPopupWindow*) self);
#line 2431 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                                    gpointer self)
{
#line 137 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_window_focus ((GalaPluginsPIPPopupWindow*) self);
#line 2440 "PopupWindow.c"
}

static GObject *
gala_plugins_pip_popup_window_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaPluginsPIPPopupWindow * self;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	gfloat scale = 0.0F;
	MetaDisplay* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWindowActor* _tmp4_;
	ClutterClone* _tmp5_;
	GalaDragDropAction* _tmp6_;
	GalaDragDropAction* _tmp7_;
	GalaDragDropAction* _tmp8_;
	GalaDragDropAction* _tmp9_;
	ClutterActor* _tmp10_ = NULL;
	ClutterActor* _tmp11_;
	ClutterClone* _tmp12_;
	ClutterActor* _tmp13_ = NULL;
	ClutterActor* _tmp14_;
	ClutterActor* _tmp15_;
	ClutterActor* _tmp16_;
	GalaShadowEffect* _tmp17_;
	GalaShadowEffect* _tmp18_;
	ClutterActor* _tmp19_;
	GalaDragDropAction* _tmp20_;
	MtkRectangle monitor_rect = {0};
	MtkRectangle _tmp21_ = {0};
	gfloat x_position = 0.0F;
	gfloat y_position = 0.0F;
	MtkRectangle _tmp27_;
	MtkRectangle _tmp28_;
	gfloat _tmp29_;
	gfloat _tmp30_;
	GalaCloseButton* _tmp31_ = NULL;
	GalaCloseButton* _tmp32_;
	ClutterAlignConstraint* _tmp33_;
	ClutterAlignConstraint* _tmp34_;
	GalaCloseButton* _tmp35_;
	ClutterAlignConstraint* _tmp36_;
	ClutterAlignConstraint* _tmp37_;
	GalaCloseButton* _tmp38_;
	ClutterActor* _tmp39_;
	ClutterActor* _tmp40_;
	ClutterActor* _tmp41_;
	ClutterActor* _tmp42_;
	ClutterAlignConstraint* _tmp43_;
	ClutterAlignConstraint* _tmp44_;
	ClutterActor* _tmp45_;
	ClutterAlignConstraint* _tmp46_;
	ClutterAlignConstraint* _tmp47_;
	ClutterActor* _tmp48_;
	ClutterActor* _tmp49_;
	GalaCloseButton* _tmp50_;
	ClutterActor* _tmp51_;
	MetaWindowActor* _tmp52_;
	ClutterActor* _tmp53_;
	MetaWindow* window = NULL;
	MetaWindowActor* _tmp54_;
	MetaWindow* _tmp55_;
	MetaWindow* _tmp56_;
	MetaWindow* _tmp57_;
	MetaWorkspaceManager* workspace_manager = NULL;
	GalaWindowManager* _tmp58_;
	MetaDisplay* _tmp59_;
	MetaWorkspaceManager* _tmp60_;
	MetaWorkspaceManager* _tmp61_;
#line 59 "../plugins/pip/PopupWindow.vala"
	parent_class = G_OBJECT_CLASS (gala_plugins_pip_popup_window_parent_class);
#line 59 "../plugins/pip/PopupWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../plugins/pip/PopupWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 60 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 60 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 60 "../plugins/pip/PopupWindow.vala"
	display = _tmp1_;
#line 61 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = display;
#line 61 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = display;
#line 61 "../plugins/pip/PopupWindow.vala"
	scale = meta_display_get_monitor_scale (_tmp2_, meta_display_get_current_monitor (_tmp3_));
#line 63 "../plugins/pip/PopupWindow.vala"
	self->priv->button_size = gala_utils_scale_to_int (36, scale);
#line 64 "../plugins/pip/PopupWindow.vala"
	self->priv->container_margin = self->priv->button_size / 2;
#line 66 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 67 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) self, 0.5f, 0.5f);
#line 68 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_IN_QUAD);
#line 70 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->_window_actor;
#line 70 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = (ClutterClone*) clutter_clone_new ((ClutterActor*) _tmp4_);
#line 70 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 70 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone);
#line 70 "../plugins/pip/PopupWindow.vala"
	self->priv->clone = _tmp5_;
#line 72 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = gala_drag_drop_action_new (GALA_DRAG_DROP_ACTION_TYPE_SOURCE, "pip");
#line 72 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp6_);
#line 72 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->move_action);
#line 72 "../plugins/pip/PopupWindow.vala"
	self->priv->move_action = _tmp6_;
#line 73 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->move_action;
#line 73 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp7_, "drag-begin", (GCallback) _gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin, self, 0);
#line 74 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->move_action;
#line 74 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp8_, "drag-canceled", (GCallback) _gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled, self, 0);
#line 75 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->move_action;
#line 75 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp9_, "actor-clicked", (GCallback) _gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked, self, 0);
#line 77 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = clutter_actor_new ();
#line 77 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp10_, "scale-x", (gdouble) 0.35f, NULL);
#line 77 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp10_, "scale-y", (gdouble) 0.35f, NULL);
#line 77 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp10_);
#line 77 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone_container);
#line 77 "../plugins/pip/PopupWindow.vala"
	self->priv->clone_container = _tmp10_;
#line 81 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->clone_container;
#line 81 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = self->priv->clone;
#line 81 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child (_tmp11_, (ClutterActor*) _tmp12_);
#line 83 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = clutter_actor_new ();
#line 83 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive (_tmp13_, TRUE);
#line 83 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 83 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->container);
#line 83 "../plugins/pip/PopupWindow.vala"
	self->priv->container = _tmp13_;
#line 86 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = self->priv->container;
#line 86 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = self->priv->clone_container;
#line 86 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child (_tmp14_, _tmp15_);
#line 87 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = self->priv->container;
#line 87 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = gala_shadow_effect_new ("window");
#line 87 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp17_);
#line 87 "../plugins/pip/PopupWindow.vala"
	_tmp18_ = _tmp17_;
#line 87 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_effect (_tmp16_, (ClutterEffect*) _tmp18_);
#line 87 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp18_);
#line 88 "../plugins/pip/PopupWindow.vala"
	_tmp19_ = self->priv->container;
#line 88 "../plugins/pip/PopupWindow.vala"
	_tmp20_ = self->priv->move_action;
#line 88 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_action (_tmp19_, (ClutterAction*) _tmp20_);
#line 90 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_size (self);
#line 97 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_current_monitor_rect (self, &_tmp21_);
#line 97 "../plugins/pip/PopupWindow.vala"
	monitor_rect = _tmp21_;
#line 100 "../plugins/pip/PopupWindow.vala"
	if (clutter_get_default_text_direction () == CLUTTER_TEXT_DIRECTION_RTL) {
#line 2633 "PopupWindow.c"
		MtkRectangle _tmp22_;
#line 101 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = monitor_rect;
#line 101 "../plugins/pip/PopupWindow.vala"
		x_position = (gfloat) (GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN + _tmp22_.x);
#line 2639 "PopupWindow.c"
	} else {
		MtkRectangle _tmp23_;
		MtkRectangle _tmp24_;
		gfloat _tmp25_;
		gfloat _tmp26_;
#line 103 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = monitor_rect;
#line 103 "../plugins/pip/PopupWindow.vala"
		_tmp24_ = monitor_rect;
#line 103 "../plugins/pip/PopupWindow.vala"
		_tmp25_ = clutter_actor_get_width ((ClutterActor*) self);
#line 103 "../plugins/pip/PopupWindow.vala"
		_tmp26_ = _tmp25_;
#line 103 "../plugins/pip/PopupWindow.vala"
		x_position = ((_tmp23_.width + _tmp24_.x) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp26_;
#line 2655 "PopupWindow.c"
	}
#line 105 "../plugins/pip/PopupWindow.vala"
	_tmp27_ = monitor_rect;
#line 105 "../plugins/pip/PopupWindow.vala"
	_tmp28_ = monitor_rect;
#line 105 "../plugins/pip/PopupWindow.vala"
	_tmp29_ = clutter_actor_get_height ((ClutterActor*) self);
#line 105 "../plugins/pip/PopupWindow.vala"
	_tmp30_ = _tmp29_;
#line 105 "../plugins/pip/PopupWindow.vala"
	y_position = ((_tmp27_.height + _tmp28_.y) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp30_;
#line 107 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position ((ClutterActor*) self, x_position, y_position);
#line 109 "../plugins/pip/PopupWindow.vala"
	_tmp31_ = gala_close_button_new (scale);
#line 109 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp31_, (guint) 0);
#line 109 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp31_);
#line 109 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->close_button);
#line 109 "../plugins/pip/PopupWindow.vala"
	self->priv->close_button = _tmp31_;
#line 113 "../plugins/pip/PopupWindow.vala"
	_tmp32_ = self->priv->close_button;
#line 113 "../plugins/pip/PopupWindow.vala"
	_tmp33_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_X_AXIS, 0.0f);
#line 113 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp33_);
#line 113 "../plugins/pip/PopupWindow.vala"
	_tmp34_ = _tmp33_;
#line 113 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint ((ClutterActor*) _tmp32_, (ClutterConstraint*) _tmp34_);
#line 113 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp34_);
#line 114 "../plugins/pip/PopupWindow.vala"
	_tmp35_ = self->priv->close_button;
#line 114 "../plugins/pip/PopupWindow.vala"
	_tmp36_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_Y_AXIS, 0.0f);
#line 114 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp36_);
#line 114 "../plugins/pip/PopupWindow.vala"
	_tmp37_ = _tmp36_;
#line 114 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint ((ClutterActor*) _tmp35_, (ClutterConstraint*) _tmp37_);
#line 114 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp37_);
#line 115 "../plugins/pip/PopupWindow.vala"
	_tmp38_ = self->priv->close_button;
#line 115 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp38_, "triggered", (GCallback) _gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered, self, 0);
#line 117 "../plugins/pip/PopupWindow.vala"
	_tmp39_ = gala_utils_create_resize_button (scale);
#line 117 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->resize_button);
#line 117 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_button = _tmp39_;
#line 118 "../plugins/pip/PopupWindow.vala"
	_tmp40_ = self->priv->resize_button;
#line 118 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp40_, (guint) 0);
#line 119 "../plugins/pip/PopupWindow.vala"
	_tmp41_ = self->priv->resize_button;
#line 119 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive (_tmp41_, TRUE);
#line 120 "../plugins/pip/PopupWindow.vala"
	_tmp42_ = self->priv->resize_button;
#line 120 "../plugins/pip/PopupWindow.vala"
	_tmp43_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_X_AXIS, 1.0f);
#line 120 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp43_);
#line 120 "../plugins/pip/PopupWindow.vala"
	_tmp44_ = _tmp43_;
#line 120 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint (_tmp42_, (ClutterConstraint*) _tmp44_);
#line 120 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp44_);
#line 121 "../plugins/pip/PopupWindow.vala"
	_tmp45_ = self->priv->resize_button;
#line 121 "../plugins/pip/PopupWindow.vala"
	_tmp46_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_Y_AXIS, 1.0f);
#line 121 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp46_);
#line 121 "../plugins/pip/PopupWindow.vala"
	_tmp47_ = _tmp46_;
#line 121 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint (_tmp45_, (ClutterConstraint*) _tmp47_);
#line 121 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp47_);
#line 122 "../plugins/pip/PopupWindow.vala"
	_tmp48_ = self->priv->resize_button;
#line 122 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp48_, "button-press-event", (GCallback) _gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event, self, 0);
#line 124 "../plugins/pip/PopupWindow.vala"
	_tmp49_ = self->priv->container;
#line 124 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp49_);
#line 125 "../plugins/pip/PopupWindow.vala"
	_tmp50_ = self->priv->close_button;
#line 125 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp50_);
#line 126 "../plugins/pip/PopupWindow.vala"
	_tmp51_ = self->priv->resize_button;
#line 126 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp51_);
#line 128 "../plugins/pip/PopupWindow.vala"
	_tmp52_ = self->priv->_window_actor;
#line 128 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object ((GObject*) _tmp52_, "notify::allocation", (GCallback) _gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify, self, 0);
#line 129 "../plugins/pip/PopupWindow.vala"
	_tmp53_ = self->priv->container;
#line 129 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position (_tmp53_, (gfloat) self->priv->container_margin, (gfloat) self->priv->container_margin);
#line 130 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_clip (self);
#line 132 "../plugins/pip/PopupWindow.vala"
	_tmp54_ = self->priv->_window_actor;
#line 132 "../plugins/pip/PopupWindow.vala"
	_tmp55_ = meta_window_actor_get_meta_window (_tmp54_);
#line 132 "../plugins/pip/PopupWindow.vala"
	window = _tmp55_;
#line 133 "../plugins/pip/PopupWindow.vala"
	_tmp56_ = window;
#line 133 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp56_, "unmanaged", (GCallback) _gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged, self, 0);
#line 134 "../plugins/pip/PopupWindow.vala"
	_tmp57_ = window;
#line 134 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object ((GObject*) _tmp57_, "notify::appears-focused", (GCallback) _gala_plugins_pip_popup_window_update_window_focus_g_object_notify, self, 0);
#line 136 "../plugins/pip/PopupWindow.vala"
	_tmp58_ = self->priv->_wm;
#line 136 "../plugins/pip/PopupWindow.vala"
	_tmp59_ = meta_plugin_get_display ((MetaPlugin*) _tmp58_);
#line 136 "../plugins/pip/PopupWindow.vala"
	_tmp60_ = meta_display_get_workspace_manager (_tmp59_);
#line 136 "../plugins/pip/PopupWindow.vala"
	workspace_manager = _tmp60_;
#line 137 "../plugins/pip/PopupWindow.vala"
	_tmp61_ = workspace_manager;
#line 137 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp61_, "active-workspace-changed", (GCallback) _gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed, self, 0);
#line 59 "../plugins/pip/PopupWindow.vala"
	return obj;
#line 2799 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_class_init (GalaPluginsPIPPopupWindowClass * klass,
                                          gpointer klass_data)
{
#line 7 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_parent_class = g_type_class_peek_parent (klass);
#line 7 "../plugins/pip/PopupWindow.vala"
	g_type_class_adjust_private_offset (klass, &GalaPluginsPIPPopupWindow_private_offset);
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->show = (void (*) (ClutterActor*)) gala_plugins_pip_popup_window_real_show;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->hide = (void (*) (ClutterActor*)) gala_plugins_pip_popup_window_real_hide;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->enter_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_plugins_pip_popup_window_real_enter_event;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->leave_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_plugins_pip_popup_window_real_leave_event;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_plugins_pip_popup_window_get_property;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_plugins_pip_popup_window_set_property;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_plugins_pip_popup_window_constructor;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_plugins_pip_popup_window_finalize;
#line 7 "../plugins/pip/PopupWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../plugins/pip/PopupWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY] = g_param_spec_object ("window-actor", "window-actor", "window-actor", meta_window_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL] = g_signal_new ("closed", GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2832 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_instance_init (GalaPluginsPIPPopupWindow * self,
                                             gpointer klass)
{
#line 7 "../plugins/pip/PopupWindow.vala"
	self->priv = gala_plugins_pip_popup_window_get_instance_private (self);
#line 29 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_width = 0.0f;
#line 30 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_height = 0.0f;
#line 31 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_x = 0.0f;
#line 32 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_y = 0.0f;
#line 34 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = FALSE;
#line 35 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 36 "../plugins/pip/PopupWindow.vala"
	self->priv->grab = NULL;
#line 2855 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_finalize (GObject * obj)
{
	GalaPluginsPIPPopupWindow * self;
#line 7 "../plugins/pip/PopupWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 19 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->_wm);
#line 20 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->_window_actor);
#line 22 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone);
#line 23 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone_container);
#line 24 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->container);
#line 25 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->close_button);
#line 26 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->resize_button);
#line 27 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->move_action);
#line 36 "../plugins/pip/PopupWindow.vala"
	_clutter_grab_unref0 (self->priv->grab);
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (gala_plugins_pip_popup_window_parent_class)->finalize (obj);
#line 2884 "PopupWindow.c"
}

 G_GNUC_NO_INLINE static GType
gala_plugins_pip_popup_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaPluginsPIPPopupWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_plugins_pip_popup_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPluginsPIPPopupWindow), 0, (GInstanceInitFunc) gala_plugins_pip_popup_window_instance_init, NULL };
	GType gala_plugins_pip_popup_window_type_id;
	gala_plugins_pip_popup_window_type_id = g_type_register_static (clutter_actor_get_type (), "GalaPluginsPIPPopupWindow", &g_define_type_info, 0);
	GalaPluginsPIPPopupWindow_private_offset = g_type_add_instance_private (gala_plugins_pip_popup_window_type_id, sizeof (GalaPluginsPIPPopupWindowPrivate));
	return gala_plugins_pip_popup_window_type_id;
}

GType
gala_plugins_pip_popup_window_get_type (void)
{
	static gsize gala_plugins_pip_popup_window_type_id__once = 0;
	if (g_once_init_enter (&gala_plugins_pip_popup_window_type_id__once)) {
		GType gala_plugins_pip_popup_window_type_id;
		gala_plugins_pip_popup_window_type_id = gala_plugins_pip_popup_window_get_type_once ();
		g_once_init_leave (&gala_plugins_pip_popup_window_type_id__once, gala_plugins_pip_popup_window_type_id);
	}
	return gala_plugins_pip_popup_window_type_id__once;
}

static void
_vala_gala_plugins_pip_popup_window_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	GalaPluginsPIPPopupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 7 "../plugins/pip/PopupWindow.vala"
	switch (property_id) {
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		g_value_set_object (value, gala_plugins_pip_popup_window_get_wm (self));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		g_value_set_object (value, gala_plugins_pip_popup_window_get_window_actor (self));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2931 "PopupWindow.c"
		default:
#line 7 "../plugins/pip/PopupWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2937 "PopupWindow.c"
	}
}

static void
_vala_gala_plugins_pip_popup_window_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	GalaPluginsPIPPopupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 7 "../plugins/pip/PopupWindow.vala"
	switch (property_id) {
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_set_wm (self, g_value_get_object (value));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_set_window_actor (self, g_value_get_object (value));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2963 "PopupWindow.c"
		default:
#line 7 "../plugins/pip/PopupWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2969 "PopupWindow.c"
	}
}

