/* BlurEffect.c generated by valac 0.56.17, the Vala compiler
 * generated from BlurEffect.vala, do not modify */

/*
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <clutter/clutter.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cogl/cogl.h>
#include <graphene-gobject.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>

#define GALA_BLUR_EFFECT_MIN_DOWNSCALE_SIZE 256.0f
#define GALA_BLUR_EFFECT_MAX_RADIUS 12.0f
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_BLUR_EFFECT (gala_blur_effect_get_type ())
#define GALA_BLUR_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BLUR_EFFECT, GalaBlurEffect))
#define GALA_BLUR_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BLUR_EFFECT, GalaBlurEffectClass))
#define GALA_IS_BLUR_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BLUR_EFFECT))
#define GALA_IS_BLUR_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BLUR_EFFECT))
#define GALA_BLUR_EFFECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BLUR_EFFECT, GalaBlurEffectClass))

typedef struct _GalaBlurEffect GalaBlurEffect;
typedef struct _GalaBlurEffectClass GalaBlurEffectClass;
typedef struct _GalaBlurEffectPrivate GalaBlurEffectPrivate;
enum  {
	GALA_BLUR_EFFECT_0_PROPERTY,
	GALA_BLUR_EFFECT_ACTOR_PROPERTY,
	GALA_BLUR_EFFECT_RADIUS_PROPERTY,
	GALA_BLUR_EFFECT_NUM_PROPERTIES
};
static GParamSpec* gala_blur_effect_properties[GALA_BLUR_EFFECT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cogl_object_unref0(var) ((var == NULL) ? NULL : (var = (cogl_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _clutter_paint_node_unref0(var) ((var == NULL) ? NULL : (var = (clutter_paint_node_unref (var), NULL)))

struct _GalaBlurEffect {
	ClutterEffect parent_instance;
	GalaBlurEffectPrivate * priv;
};

struct _GalaBlurEffectClass {
	ClutterEffectClass parent_class;
};

struct _GalaBlurEffectPrivate {
	ClutterActor* _actor;
	gfloat _radius;
	gboolean actor_painted;
	gboolean blur_applied;
	gint texture_width;
	gint texture_height;
	gfloat downscale_factor;
	CoglFramebuffer* actor_framebuffer;
	CoglPipeline* actor_pipeline;
	CoglTexture* actor_texture;
	CoglFramebuffer* framebuffer;
	CoglPipeline* pipeline;
	CoglTexture* texture;
};

static gint GalaBlurEffect_private_offset;
static gpointer gala_blur_effect_parent_class = NULL;

VALA_EXTERN GType gala_blur_effect_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaBlurEffect, g_object_unref)
VALA_EXTERN GalaBlurEffect* gala_blur_effect_new (ClutterActor* actor,
                                      gfloat radius);
VALA_EXTERN GalaBlurEffect* gala_blur_effect_construct (GType object_type,
                                            ClutterActor* actor,
                                            gfloat radius);
static gboolean gala_blur_effect_needs_repaint (GalaBlurEffect* self,
                                         ClutterEffectPaintFlags flags);
static void gala_blur_effect_update_actor_box (GalaBlurEffect* self,
                                        ClutterPaintContext* paint_context,
                                        ClutterActorBox* result);
VALA_EXTERN ClutterActor* gala_blur_effect_get_actor (GalaBlurEffect* self);
static gfloat gala_blur_effect_calculate_downscale_factor (GalaBlurEffect* self,
                                                    gfloat width,
                                                    gfloat height,
                                                    gfloat radius);
static void gala_blur_effect_setup_projection_matrix (GalaBlurEffect* self,
                                               CoglFramebuffer* framebuffer,
                                               gfloat width,
                                               gfloat height);
static gboolean gala_blur_effect_update_general_fbo (GalaBlurEffect* self,
                                              gint width,
                                              gint height,
                                              gfloat downscale_factor);
static gboolean gala_blur_effect_update_actor_fbo (GalaBlurEffect* self,
                                            gint width,
                                            gint height,
                                            gfloat downscale_factor);
static gboolean gala_blur_effect_update_framebuffers (GalaBlurEffect* self,
                                               ClutterPaintContext* paint_context,
                                               ClutterActorBox* actor_box);
VALA_EXTERN gfloat gala_blur_effect_get_radius (GalaBlurEffect* self);
static ClutterPaintNode* gala_blur_effect_create_blur_nodes (GalaBlurEffect* self,
                                                      ClutterPaintNode* node);
static void gala_blur_effect_paint_actor_offscreen (GalaBlurEffect* self,
                                             ClutterPaintNode* node,
                                             ClutterEffectPaintFlags flags);
static void gala_blur_effect_add_actor_node (GalaBlurEffect* self,
                                      ClutterPaintNode* node);
static void gala_blur_effect_add_blurred_pipeline (GalaBlurEffect* self,
                                            ClutterPaintNode* node);
static void gala_blur_effect_real_paint_node (ClutterEffect* base,
                                       ClutterPaintNode* node,
                                       ClutterPaintContext* paint_context,
                                       ClutterEffectPaintFlags flags);
static void gala_blur_effect_set_actor (GalaBlurEffect* self,
                                 ClutterActor* value);
static void gala_blur_effect_set_radius (GalaBlurEffect* self,
                                  gfloat value);
static GObject * gala_blur_effect_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void gala_blur_effect_finalize (GObject * obj);
static GType gala_blur_effect_get_type_once (void);
static void _vala_gala_blur_effect_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_gala_blur_effect_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
gala_blur_effect_get_instance_private (GalaBlurEffect* self)
{
	return G_STRUCT_MEMBER_P (self, GalaBlurEffect_private_offset);
}

GalaBlurEffect*
gala_blur_effect_construct (GType object_type,
                            ClutterActor* actor,
                            gfloat radius)
{
	GalaBlurEffect * self = NULL;
#line 27 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 28 "../src/Background/BlurEffect.vala"
	self = (GalaBlurEffect*) g_object_new (object_type, "actor", actor, "radius", radius, NULL);
#line 27 "../src/Background/BlurEffect.vala"
	return self;
#line 174 "BlurEffect.c"
}

GalaBlurEffect*
gala_blur_effect_new (ClutterActor* actor,
                      gfloat radius)
{
#line 27 "../src/Background/BlurEffect.vala"
	return gala_blur_effect_construct (GALA_TYPE_BLUR_EFFECT, actor, radius);
#line 183 "BlurEffect.c"
}

static gboolean
gala_blur_effect_needs_repaint (GalaBlurEffect* self,
                                ClutterEffectPaintFlags flags)
{
	gboolean actor_dirty = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 45 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "../src/Background/BlurEffect.vala"
	actor_dirty = (flags & CLUTTER_EFFECT_PAINT_ACTOR_DIRTY) != 0;
#line 48 "../src/Background/BlurEffect.vala"
	if (actor_dirty) {
#line 48 "../src/Background/BlurEffect.vala"
		_tmp1_ = TRUE;
#line 202 "BlurEffect.c"
	} else {
#line 48 "../src/Background/BlurEffect.vala"
		_tmp1_ = !self->priv->blur_applied;
#line 206 "BlurEffect.c"
	}
#line 48 "../src/Background/BlurEffect.vala"
	if (_tmp1_) {
#line 48 "../src/Background/BlurEffect.vala"
		_tmp0_ = TRUE;
#line 212 "BlurEffect.c"
	} else {
#line 48 "../src/Background/BlurEffect.vala"
		_tmp0_ = !self->priv->actor_painted;
#line 216 "BlurEffect.c"
	}
#line 48 "../src/Background/BlurEffect.vala"
	result = _tmp0_;
#line 48 "../src/Background/BlurEffect.vala"
	return result;
#line 222 "BlurEffect.c"
}

static void
gala_blur_effect_update_actor_box (GalaBlurEffect* self,
                                   ClutterPaintContext* paint_context,
                                   ClutterActorBox* result)
{
	ClutterActorBox actor_allocation_box = {0};
	ClutterActor* _tmp0_;
	ClutterActorBox _tmp1_ = {0};
#line 51 "../src/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/Background/BlurEffect.vala"
	g_return_if_fail (paint_context != NULL);
#line 52 "../src/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_actor;
#line 52 "../src/Background/BlurEffect.vala"
	clutter_actor_get_allocation_box (_tmp0_, &_tmp1_);
#line 52 "../src/Background/BlurEffect.vala"
	actor_allocation_box = _tmp1_;
#line 53 "../src/Background/BlurEffect.vala"
	clutter_actor_box_clamp_to_pixel (&actor_allocation_box);
#line 55 "../src/Background/BlurEffect.vala"
	*result = actor_allocation_box;
#line 55 "../src/Background/BlurEffect.vala"
	return;
#line 249 "BlurEffect.c"
}

static gfloat
gala_blur_effect_calculate_downscale_factor (GalaBlurEffect* self,
                                             gfloat width,
                                             gfloat height,
                                             gfloat radius)
{
	gfloat downscale_factor = 0.0F;
	gfloat scaled_width = 0.0F;
	gfloat scaled_height = 0.0F;
	gfloat scaled_radius = 0.0F;
	gfloat result;
#line 58 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 59 "../src/Background/BlurEffect.vala"
	downscale_factor = 1.0f;
#line 60 "../src/Background/BlurEffect.vala"
	scaled_width = width;
#line 61 "../src/Background/BlurEffect.vala"
	scaled_height = height;
#line 62 "../src/Background/BlurEffect.vala"
	scaled_radius = radius;
#line 68 "../src/Background/BlurEffect.vala"
	while (TRUE) {
#line 275 "BlurEffect.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
#line 69 "../src/Background/BlurEffect.vala"
		if (scaled_radius > GALA_BLUR_EFFECT_MAX_RADIUS) {
#line 70 "../src/Background/BlurEffect.vala"
			_tmp1_ = scaled_width > GALA_BLUR_EFFECT_MIN_DOWNSCALE_SIZE;
#line 282 "BlurEffect.c"
		} else {
#line 69 "../src/Background/BlurEffect.vala"
			_tmp1_ = FALSE;
#line 286 "BlurEffect.c"
		}
#line 69 "../src/Background/BlurEffect.vala"
		if (_tmp1_) {
#line 71 "../src/Background/BlurEffect.vala"
			_tmp0_ = scaled_height > GALA_BLUR_EFFECT_MIN_DOWNSCALE_SIZE;
#line 292 "BlurEffect.c"
		} else {
#line 69 "../src/Background/BlurEffect.vala"
			_tmp0_ = FALSE;
#line 296 "BlurEffect.c"
		}
#line 69 "../src/Background/BlurEffect.vala"
		if (!_tmp0_) {
#line 69 "../src/Background/BlurEffect.vala"
			break;
#line 302 "BlurEffect.c"
		}
#line 73 "../src/Background/BlurEffect.vala"
		downscale_factor *= 2.0f;
#line 75 "../src/Background/BlurEffect.vala"
		scaled_width = width / downscale_factor;
#line 76 "../src/Background/BlurEffect.vala"
		scaled_height = height / downscale_factor;
#line 77 "../src/Background/BlurEffect.vala"
		scaled_radius = radius / downscale_factor;
#line 312 "BlurEffect.c"
	}
#line 80 "../src/Background/BlurEffect.vala"
	result = downscale_factor;
#line 80 "../src/Background/BlurEffect.vala"
	return result;
#line 318 "BlurEffect.c"
}

static void
gala_blur_effect_setup_projection_matrix (GalaBlurEffect* self,
                                          CoglFramebuffer* framebuffer,
                                          gfloat width,
                                          gfloat height)
{
	graphene_matrix_t projection = {0};
	graphene_matrix_t _tmp0_ = {0};
	graphene_point3d_t _tmp1_ = {0};
	graphene_matrix_t _tmp2_;
#line 83 "../src/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/Background/BlurEffect.vala"
	g_return_if_fail (framebuffer != NULL);
#line 84 "../src/Background/BlurEffect.vala"
	projection = _tmp0_;
#line 85 "../src/Background/BlurEffect.vala"
	_tmp1_.x = (-width) / 2.0f;
#line 85 "../src/Background/BlurEffect.vala"
	_tmp1_.y = (-height) / 2.0f;
#line 85 "../src/Background/BlurEffect.vala"
	_tmp1_.z = 0.0f;
#line 85 "../src/Background/BlurEffect.vala"
	graphene_matrix_init_translate (&projection, &_tmp1_);
#line 86 "../src/Background/BlurEffect.vala"
	graphene_matrix_scale (&projection, 2.0f / width, (-2.0f) / height, 1.0f);
#line 88 "../src/Background/BlurEffect.vala"
	_tmp2_ = projection;
#line 88 "../src/Background/BlurEffect.vala"
	cogl_framebuffer_set_projection_matrix (framebuffer, &_tmp2_);
#line 351 "BlurEffect.c"
}

static gboolean
gala_blur_effect_update_general_fbo (GalaBlurEffect* self,
                                     gint width,
                                     gint height,
                                     gfloat downscale_factor)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	CoglContext* ctx = NULL;
	ClutterBackend* _tmp4_;
	CoglContext* _tmp5_;
	gint new_width = 0;
	gint new_height = 0;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp6_;
	CoglPipeline* _tmp17_;
	CoglTexture* _tmp18_;
	CoglTexture* _tmp19_;
	CoglOffscreen* _tmp20_;
	CoglFramebuffer* _tmp21_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 91 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../src/Background/BlurEffect.vala"
	if (self->priv->texture_width == width) {
#line 94 "../src/Background/BlurEffect.vala"
		_tmp2_ = self->priv->texture_height == height;
#line 383 "BlurEffect.c"
	} else {
#line 93 "../src/Background/BlurEffect.vala"
		_tmp2_ = FALSE;
#line 387 "BlurEffect.c"
	}
#line 93 "../src/Background/BlurEffect.vala"
	if (_tmp2_) {
#line 95 "../src/Background/BlurEffect.vala"
		_tmp1_ = self->priv->downscale_factor == downscale_factor;
#line 393 "BlurEffect.c"
	} else {
#line 93 "../src/Background/BlurEffect.vala"
		_tmp1_ = FALSE;
#line 397 "BlurEffect.c"
	}
#line 93 "../src/Background/BlurEffect.vala"
	if (_tmp1_) {
#line 401 "BlurEffect.c"
		CoglFramebuffer* _tmp3_;
#line 96 "../src/Background/BlurEffect.vala"
		_tmp3_ = self->priv->framebuffer;
#line 96 "../src/Background/BlurEffect.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 407 "BlurEffect.c"
	} else {
#line 93 "../src/Background/BlurEffect.vala"
		_tmp0_ = FALSE;
#line 411 "BlurEffect.c"
	}
#line 92 "../src/Background/BlurEffect.vala"
	if (_tmp0_) {
#line 98 "../src/Background/BlurEffect.vala"
		result = TRUE;
#line 98 "../src/Background/BlurEffect.vala"
		return result;
#line 419 "BlurEffect.c"
	}
#line 101 "../src/Background/BlurEffect.vala"
	_tmp4_ = clutter_get_default_backend ();
#line 101 "../src/Background/BlurEffect.vala"
	_tmp5_ = clutter_backend_get_cogl_context (_tmp4_);
#line 101 "../src/Background/BlurEffect.vala"
	ctx = _tmp5_;
#line 103 "../src/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->framebuffer);
#line 103 "../src/Background/BlurEffect.vala"
	self->priv->framebuffer = NULL;
#line 104 "../src/Background/BlurEffect.vala"
	_cogl_object_unref0 (self->priv->texture);
#line 104 "../src/Background/BlurEffect.vala"
	self->priv->texture = NULL;
#line 106 "../src/Background/BlurEffect.vala"
	new_width = (gint) floorf (width / downscale_factor);
#line 107 "../src/Background/BlurEffect.vala"
	new_height = (gint) floorf (height / downscale_factor);
#line 109 "../src/Background/BlurEffect.vala"
	_tmp6_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, new_width, new_height);
#line 109 "../src/Background/BlurEffect.vala"
	surface = _tmp6_;
#line 443 "BlurEffect.c"
	{
		CoglTexture2D* _tmp7_ = NULL;
		CoglContext* _tmp8_;
		cairo_surface_t* _tmp9_;
		cairo_surface_t* _tmp10_;
		guchar* _tmp11_;
		CoglTexture2D* _tmp12_;
		CoglTexture2D* _tmp13_;
#line 112 "../src/Background/BlurEffect.vala"
		_tmp8_ = ctx;
#line 112 "../src/Background/BlurEffect.vala"
		_tmp9_ = surface;
#line 112 "../src/Background/BlurEffect.vala"
		_tmp10_ = surface;
#line 112 "../src/Background/BlurEffect.vala"
		_tmp11_ = cairo_image_surface_get_data (_tmp10_);
#line 112 "../src/Background/BlurEffect.vala"
		_tmp12_ = cogl_texture_2d_new_from_data (_tmp8_, new_width, new_height, COGL_PIXEL_FORMAT_BGRA_8888_PRE, cairo_image_surface_get_stride (_tmp9_), (const uint8_t*) _tmp11_, &_inner_error0_);
#line 112 "../src/Background/BlurEffect.vala"
		_tmp7_ = _tmp12_;
#line 112 "../src/Background/BlurEffect.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 466 "BlurEffect.c"
			goto __catch0_g_error;
		}
#line 112 "../src/Background/BlurEffect.vala"
		_tmp13_ = _tmp7_;
#line 112 "../src/Background/BlurEffect.vala"
		_tmp7_ = NULL;
#line 112 "../src/Background/BlurEffect.vala"
		_cogl_object_unref0 (self->priv->texture);
#line 112 "../src/Background/BlurEffect.vala"
		self->priv->texture = (CoglTexture*) _tmp13_;
#line 111 "../src/Background/BlurEffect.vala"
		_cogl_object_unref0 (_tmp7_);
#line 479 "BlurEffect.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 111 "../src/Background/BlurEffect.vala"
		e = _inner_error0_;
#line 111 "../src/Background/BlurEffect.vala"
		_inner_error0_ = NULL;
#line 114 "../src/Background/BlurEffect.vala"
		_tmp14_ = e;
#line 114 "../src/Background/BlurEffect.vala"
		_tmp15_ = _tmp14_->message;
#line 114 "../src/Background/BlurEffect.vala"
		g_warning ("BlurEffect.vala:114: %s", _tmp15_);
#line 115 "../src/Background/BlurEffect.vala"
		result = FALSE;
#line 115 "../src/Background/BlurEffect.vala"
		_g_error_free0 (e);
#line 115 "../src/Background/BlurEffect.vala"
		_cairo_surface_destroy0 (surface);
#line 115 "../src/Background/BlurEffect.vala"
		return result;
#line 505 "BlurEffect.c"
	}
	__finally0:
#line 111 "../src/Background/BlurEffect.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 510 "BlurEffect.c"
		gboolean _tmp16_ = FALSE;
#line 111 "../src/Background/BlurEffect.vala"
		_cairo_surface_destroy0 (surface);
#line 111 "../src/Background/BlurEffect.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "../src/Background/BlurEffect.vala"
		g_clear_error (&_inner_error0_);
#line 111 "../src/Background/BlurEffect.vala"
		return _tmp16_;
#line 520 "BlurEffect.c"
	}
#line 118 "../src/Background/BlurEffect.vala"
	_tmp17_ = self->priv->pipeline;
#line 118 "../src/Background/BlurEffect.vala"
	_tmp18_ = self->priv->texture;
#line 118 "../src/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_texture (_tmp17_, 0, _tmp18_);
#line 120 "../src/Background/BlurEffect.vala"
	_tmp19_ = self->priv->texture;
#line 120 "../src/Background/BlurEffect.vala"
	_tmp20_ = cogl_offscreen_new_with_texture (_tmp19_);
#line 120 "../src/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->framebuffer);
#line 120 "../src/Background/BlurEffect.vala"
	self->priv->framebuffer = (CoglFramebuffer*) _tmp20_;
#line 122 "../src/Background/BlurEffect.vala"
	_tmp21_ = self->priv->framebuffer;
#line 122 "../src/Background/BlurEffect.vala"
	gala_blur_effect_setup_projection_matrix (self, _tmp21_, (gfloat) new_width, (gfloat) new_height);
#line 124 "../src/Background/BlurEffect.vala"
	result = TRUE;
#line 124 "../src/Background/BlurEffect.vala"
	_cairo_surface_destroy0 (surface);
#line 124 "../src/Background/BlurEffect.vala"
	return result;
#line 546 "BlurEffect.c"
}

static gboolean
gala_blur_effect_update_actor_fbo (GalaBlurEffect* self,
                                   gint width,
                                   gint height,
                                   gfloat downscale_factor)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	CoglContext* ctx = NULL;
	ClutterBackend* _tmp4_;
	CoglContext* _tmp5_;
	gint new_width = 0;
	gint new_height = 0;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp6_;
	CoglPipeline* _tmp17_;
	CoglTexture* _tmp18_;
	CoglTexture* _tmp19_;
	CoglOffscreen* _tmp20_;
	CoglFramebuffer* _tmp21_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 127 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "../src/Background/BlurEffect.vala"
	if (self->priv->texture_width == width) {
#line 130 "../src/Background/BlurEffect.vala"
		_tmp2_ = self->priv->texture_height == height;
#line 578 "BlurEffect.c"
	} else {
#line 129 "../src/Background/BlurEffect.vala"
		_tmp2_ = FALSE;
#line 582 "BlurEffect.c"
	}
#line 129 "../src/Background/BlurEffect.vala"
	if (_tmp2_) {
#line 131 "../src/Background/BlurEffect.vala"
		_tmp1_ = self->priv->downscale_factor == downscale_factor;
#line 588 "BlurEffect.c"
	} else {
#line 129 "../src/Background/BlurEffect.vala"
		_tmp1_ = FALSE;
#line 592 "BlurEffect.c"
	}
#line 129 "../src/Background/BlurEffect.vala"
	if (_tmp1_) {
#line 596 "BlurEffect.c"
		CoglFramebuffer* _tmp3_;
#line 132 "../src/Background/BlurEffect.vala"
		_tmp3_ = self->priv->actor_framebuffer;
#line 132 "../src/Background/BlurEffect.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 602 "BlurEffect.c"
	} else {
#line 129 "../src/Background/BlurEffect.vala"
		_tmp0_ = FALSE;
#line 606 "BlurEffect.c"
	}
#line 128 "../src/Background/BlurEffect.vala"
	if (_tmp0_) {
#line 134 "../src/Background/BlurEffect.vala"
		result = TRUE;
#line 134 "../src/Background/BlurEffect.vala"
		return result;
#line 614 "BlurEffect.c"
	}
#line 137 "../src/Background/BlurEffect.vala"
	self->priv->actor_painted = FALSE;
#line 139 "../src/Background/BlurEffect.vala"
	_tmp4_ = clutter_get_default_backend ();
#line 139 "../src/Background/BlurEffect.vala"
	_tmp5_ = clutter_backend_get_cogl_context (_tmp4_);
#line 139 "../src/Background/BlurEffect.vala"
	ctx = _tmp5_;
#line 141 "../src/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->actor_framebuffer);
#line 141 "../src/Background/BlurEffect.vala"
	self->priv->actor_framebuffer = NULL;
#line 142 "../src/Background/BlurEffect.vala"
	_cogl_object_unref0 (self->priv->actor_texture);
#line 142 "../src/Background/BlurEffect.vala"
	self->priv->actor_texture = NULL;
#line 144 "../src/Background/BlurEffect.vala"
	new_width = (gint) floorf (width / downscale_factor);
#line 145 "../src/Background/BlurEffect.vala"
	new_height = (gint) floorf (height / downscale_factor);
#line 147 "../src/Background/BlurEffect.vala"
	_tmp6_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, new_width, new_height);
#line 147 "../src/Background/BlurEffect.vala"
	surface = _tmp6_;
#line 640 "BlurEffect.c"
	{
		CoglTexture2D* _tmp7_ = NULL;
		CoglContext* _tmp8_;
		cairo_surface_t* _tmp9_;
		cairo_surface_t* _tmp10_;
		guchar* _tmp11_;
		CoglTexture2D* _tmp12_;
		CoglTexture2D* _tmp13_;
#line 150 "../src/Background/BlurEffect.vala"
		_tmp8_ = ctx;
#line 150 "../src/Background/BlurEffect.vala"
		_tmp9_ = surface;
#line 150 "../src/Background/BlurEffect.vala"
		_tmp10_ = surface;
#line 150 "../src/Background/BlurEffect.vala"
		_tmp11_ = cairo_image_surface_get_data (_tmp10_);
#line 150 "../src/Background/BlurEffect.vala"
		_tmp12_ = cogl_texture_2d_new_from_data (_tmp8_, new_width, new_height, COGL_PIXEL_FORMAT_BGRA_8888_PRE, cairo_image_surface_get_stride (_tmp9_), (const uint8_t*) _tmp11_, &_inner_error0_);
#line 150 "../src/Background/BlurEffect.vala"
		_tmp7_ = _tmp12_;
#line 150 "../src/Background/BlurEffect.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 663 "BlurEffect.c"
			goto __catch0_g_error;
		}
#line 150 "../src/Background/BlurEffect.vala"
		_tmp13_ = _tmp7_;
#line 150 "../src/Background/BlurEffect.vala"
		_tmp7_ = NULL;
#line 150 "../src/Background/BlurEffect.vala"
		_cogl_object_unref0 (self->priv->actor_texture);
#line 150 "../src/Background/BlurEffect.vala"
		self->priv->actor_texture = (CoglTexture*) _tmp13_;
#line 149 "../src/Background/BlurEffect.vala"
		_cogl_object_unref0 (_tmp7_);
#line 676 "BlurEffect.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 149 "../src/Background/BlurEffect.vala"
		e = _inner_error0_;
#line 149 "../src/Background/BlurEffect.vala"
		_inner_error0_ = NULL;
#line 152 "../src/Background/BlurEffect.vala"
		_tmp14_ = e;
#line 152 "../src/Background/BlurEffect.vala"
		_tmp15_ = _tmp14_->message;
#line 152 "../src/Background/BlurEffect.vala"
		g_warning ("BlurEffect.vala:152: %s", _tmp15_);
#line 153 "../src/Background/BlurEffect.vala"
		result = FALSE;
#line 153 "../src/Background/BlurEffect.vala"
		_g_error_free0 (e);
#line 153 "../src/Background/BlurEffect.vala"
		_cairo_surface_destroy0 (surface);
#line 153 "../src/Background/BlurEffect.vala"
		return result;
#line 702 "BlurEffect.c"
	}
	__finally0:
#line 149 "../src/Background/BlurEffect.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 707 "BlurEffect.c"
		gboolean _tmp16_ = FALSE;
#line 149 "../src/Background/BlurEffect.vala"
		_cairo_surface_destroy0 (surface);
#line 149 "../src/Background/BlurEffect.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/Background/BlurEffect.vala"
		g_clear_error (&_inner_error0_);
#line 149 "../src/Background/BlurEffect.vala"
		return _tmp16_;
#line 717 "BlurEffect.c"
	}
#line 156 "../src/Background/BlurEffect.vala"
	_tmp17_ = self->priv->actor_pipeline;
#line 156 "../src/Background/BlurEffect.vala"
	_tmp18_ = self->priv->actor_texture;
#line 156 "../src/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_texture (_tmp17_, 0, _tmp18_);
#line 158 "../src/Background/BlurEffect.vala"
	_tmp19_ = self->priv->actor_texture;
#line 158 "../src/Background/BlurEffect.vala"
	_tmp20_ = cogl_offscreen_new_with_texture (_tmp19_);
#line 158 "../src/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->actor_framebuffer);
#line 158 "../src/Background/BlurEffect.vala"
	self->priv->actor_framebuffer = G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, cogl_framebuffer_get_type (), CoglFramebuffer);
#line 160 "../src/Background/BlurEffect.vala"
	_tmp21_ = self->priv->actor_framebuffer;
#line 160 "../src/Background/BlurEffect.vala"
	gala_blur_effect_setup_projection_matrix (self, _tmp21_, (gfloat) new_width, (gfloat) new_height);
#line 162 "../src/Background/BlurEffect.vala"
	result = TRUE;
#line 162 "../src/Background/BlurEffect.vala"
	_cairo_surface_destroy0 (surface);
#line 162 "../src/Background/BlurEffect.vala"
	return result;
#line 743 "BlurEffect.c"
}

static gboolean
gala_blur_effect_update_framebuffers (GalaBlurEffect* self,
                                      ClutterPaintContext* paint_context,
                                      ClutterActorBox* actor_box)
{
	gint width = 0;
	gint height = 0;
	gfloat downscale_factor = 0.0F;
	gfloat _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean updated = FALSE;
	gboolean result;
#line 165 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (paint_context != NULL, FALSE);
#line 165 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (actor_box != NULL, FALSE);
#line 166 "../src/Background/BlurEffect.vala"
	width = (gint) clutter_actor_box_get_width (actor_box);
#line 167 "../src/Background/BlurEffect.vala"
	height = (gint) clutter_actor_box_get_height (actor_box);
#line 169 "../src/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_radius;
#line 169 "../src/Background/BlurEffect.vala"
	downscale_factor = gala_blur_effect_calculate_downscale_factor (self, (gfloat) width, (gfloat) height, _tmp0_);
#line 171 "../src/Background/BlurEffect.vala"
	if (gala_blur_effect_update_actor_fbo (self, width, height, downscale_factor)) {
#line 171 "../src/Background/BlurEffect.vala"
		_tmp1_ = gala_blur_effect_update_general_fbo (self, width, height, downscale_factor);
#line 776 "BlurEffect.c"
	} else {
#line 171 "../src/Background/BlurEffect.vala"
		_tmp1_ = FALSE;
#line 780 "BlurEffect.c"
	}
#line 171 "../src/Background/BlurEffect.vala"
	updated = _tmp1_;
#line 173 "../src/Background/BlurEffect.vala"
	self->priv->texture_width = width;
#line 174 "../src/Background/BlurEffect.vala"
	self->priv->texture_height = height;
#line 175 "../src/Background/BlurEffect.vala"
	self->priv->downscale_factor = downscale_factor;
#line 177 "../src/Background/BlurEffect.vala"
	result = updated;
#line 177 "../src/Background/BlurEffect.vala"
	return result;
#line 794 "BlurEffect.c"
}

static ClutterPaintNode*
gala_blur_effect_create_blur_nodes (GalaBlurEffect* self,
                                    ClutterPaintNode* node)
{
	gfloat width = 0.0F;
	gfloat height = 0.0F;
	ClutterActor* _tmp0_;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	ClutterLayerNode* general_node = NULL;
	CoglFramebuffer* _tmp3_;
	CoglPipeline* _tmp4_;
	ClutterLayerNode* _tmp5_;
	ClutterActorBox _tmp6_ = {0};
	ClutterBlurNode* blur_node = NULL;
	gfloat _tmp7_;
	ClutterBlurNode* _tmp8_;
	CoglTexture* _tmp9_;
	CoglTexture* _tmp10_;
	ClutterActorBox _tmp11_ = {0};
	ClutterPaintNode* result;
#line 180 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 180 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 182 "../src/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_actor;
#line 182 "../src/Background/BlurEffect.vala"
	clutter_actor_get_size (_tmp0_, &_tmp1_, &_tmp2_);
#line 182 "../src/Background/BlurEffect.vala"
	width = _tmp1_;
#line 182 "../src/Background/BlurEffect.vala"
	height = _tmp2_;
#line 184 "../src/Background/BlurEffect.vala"
	_tmp3_ = self->priv->framebuffer;
#line 184 "../src/Background/BlurEffect.vala"
	_tmp4_ = self->priv->pipeline;
#line 184 "../src/Background/BlurEffect.vala"
	_tmp5_ = (ClutterLayerNode*) clutter_layer_node_new_to_framebuffer (_tmp3_, _tmp4_);
#line 184 "../src/Background/BlurEffect.vala"
	general_node = _tmp5_;
#line 185 "../src/Background/BlurEffect.vala"
	clutter_paint_node_add_child (node, (ClutterPaintNode*) general_node);
#line 186 "../src/Background/BlurEffect.vala"
	_tmp6_.x1 = 0.0f;
#line 186 "../src/Background/BlurEffect.vala"
	_tmp6_.y1 = 0.0f;
#line 186 "../src/Background/BlurEffect.vala"
	_tmp6_.x2 = width;
#line 186 "../src/Background/BlurEffect.vala"
	_tmp6_.y2 = height;
#line 186 "../src/Background/BlurEffect.vala"
	clutter_paint_node_add_rectangle ((ClutterPaintNode*) general_node, &_tmp6_);
#line 188 "../src/Background/BlurEffect.vala"
	_tmp7_ = self->priv->_radius;
#line 188 "../src/Background/BlurEffect.vala"
	_tmp8_ = (ClutterBlurNode*) clutter_blur_node_new ((guint) (self->priv->texture_width / self->priv->downscale_factor), (guint) (self->priv->texture_height / self->priv->downscale_factor), _tmp7_ / self->priv->downscale_factor);
#line 188 "../src/Background/BlurEffect.vala"
	blur_node = _tmp8_;
#line 193 "../src/Background/BlurEffect.vala"
	clutter_paint_node_add_child ((ClutterPaintNode*) general_node, (ClutterPaintNode*) blur_node);
#line 194 "../src/Background/BlurEffect.vala"
	_tmp9_ = self->priv->texture;
#line 194 "../src/Background/BlurEffect.vala"
	_tmp10_ = self->priv->texture;
#line 194 "../src/Background/BlurEffect.vala"
	_tmp11_.x1 = 0.0f;
#line 194 "../src/Background/BlurEffect.vala"
	_tmp11_.y1 = 0.0f;
#line 194 "../src/Background/BlurEffect.vala"
	_tmp11_.x2 = (gfloat) cogl_texture_get_width (_tmp9_);
#line 194 "../src/Background/BlurEffect.vala"
	_tmp11_.y2 = (gfloat) cogl_texture_get_height (_tmp10_);
#line 194 "../src/Background/BlurEffect.vala"
	clutter_paint_node_add_rectangle ((ClutterPaintNode*) blur_node, &_tmp11_);
#line 201 "../src/Background/BlurEffect.vala"
	self->priv->blur_applied = TRUE;
#line 203 "../src/Background/BlurEffect.vala"
	result = (ClutterPaintNode*) blur_node;
#line 203 "../src/Background/BlurEffect.vala"
	_clutter_paint_node_unref0 (general_node);
#line 203 "../src/Background/BlurEffect.vala"
	return result;
#line 880 "BlurEffect.c"
}

static void
gala_blur_effect_paint_actor_offscreen (GalaBlurEffect* self,
                                        ClutterPaintNode* node,
                                        ClutterEffectPaintFlags flags)
{
	gboolean actor_dirty = FALSE;
	gboolean _tmp0_ = FALSE;
#line 206 "../src/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/Background/BlurEffect.vala"
	g_return_if_fail (node != NULL);
#line 207 "../src/Background/BlurEffect.vala"
	actor_dirty = (flags & CLUTTER_EFFECT_PAINT_ACTOR_DIRTY) != 0;
#line 210 "../src/Background/BlurEffect.vala"
	if (actor_dirty) {
#line 210 "../src/Background/BlurEffect.vala"
		_tmp0_ = TRUE;
#line 900 "BlurEffect.c"
	} else {
#line 210 "../src/Background/BlurEffect.vala"
		_tmp0_ = !self->priv->actor_painted;
#line 904 "BlurEffect.c"
	}
#line 210 "../src/Background/BlurEffect.vala"
	if (_tmp0_) {
#line 908 "BlurEffect.c"
		ClutterLayerNode* layer_node = NULL;
		CoglFramebuffer* _tmp1_;
		CoglPipeline* _tmp2_;
		ClutterLayerNode* _tmp3_;
		ClutterLayerNode* _tmp4_;
		ClutterLayerNode* _tmp5_;
		ClutterActorBox _tmp6_ = {0};
		graphene_matrix_t transform = {0};
		graphene_matrix_t _tmp7_ = {0};
		ClutterTransformNode* transform_node = NULL;
		graphene_matrix_t _tmp8_;
		ClutterTransformNode* _tmp9_;
		ClutterLayerNode* _tmp10_;
		ClutterTransformNode* _tmp11_;
		ClutterTransformNode* _tmp12_;
#line 212 "../src/Background/BlurEffect.vala"
		_tmp1_ = self->priv->actor_framebuffer;
#line 212 "../src/Background/BlurEffect.vala"
		_tmp2_ = self->priv->actor_pipeline;
#line 212 "../src/Background/BlurEffect.vala"
		_tmp3_ = (ClutterLayerNode*) clutter_layer_node_new_to_framebuffer (_tmp1_, _tmp2_);
#line 212 "../src/Background/BlurEffect.vala"
		layer_node = _tmp3_;
#line 213 "../src/Background/BlurEffect.vala"
		_tmp4_ = layer_node;
#line 213 "../src/Background/BlurEffect.vala"
		clutter_paint_node_add_child (node, (ClutterPaintNode*) _tmp4_);
#line 214 "../src/Background/BlurEffect.vala"
		_tmp5_ = layer_node;
#line 214 "../src/Background/BlurEffect.vala"
		_tmp6_.x1 = 0.0f;
#line 214 "../src/Background/BlurEffect.vala"
		_tmp6_.y1 = 0.0f;
#line 214 "../src/Background/BlurEffect.vala"
		_tmp6_.x2 = self->priv->texture_width / self->priv->downscale_factor;
#line 214 "../src/Background/BlurEffect.vala"
		_tmp6_.y2 = self->priv->texture_height / self->priv->downscale_factor;
#line 214 "../src/Background/BlurEffect.vala"
		clutter_paint_node_add_rectangle ((ClutterPaintNode*) _tmp5_, &_tmp6_);
#line 222 "../src/Background/BlurEffect.vala"
		transform = _tmp7_;
#line 223 "../src/Background/BlurEffect.vala"
		graphene_matrix_init_scale (&transform, 1.0f / self->priv->downscale_factor, 1.0f / self->priv->downscale_factor, 1.0f);
#line 228 "../src/Background/BlurEffect.vala"
		_tmp8_ = transform;
#line 228 "../src/Background/BlurEffect.vala"
		_tmp9_ = (ClutterTransformNode*) clutter_transform_node_new (&_tmp8_);
#line 228 "../src/Background/BlurEffect.vala"
		transform_node = _tmp9_;
#line 229 "../src/Background/BlurEffect.vala"
		_tmp10_ = layer_node;
#line 229 "../src/Background/BlurEffect.vala"
		_tmp11_ = transform_node;
#line 229 "../src/Background/BlurEffect.vala"
		clutter_paint_node_add_child ((ClutterPaintNode*) _tmp10_, (ClutterPaintNode*) _tmp11_);
#line 232 "../src/Background/BlurEffect.vala"
		_tmp12_ = transform_node;
#line 232 "../src/Background/BlurEffect.vala"
		gala_blur_effect_add_actor_node (self, (ClutterPaintNode*) _tmp12_);
#line 234 "../src/Background/BlurEffect.vala"
		self->priv->actor_painted = TRUE;
#line 210 "../src/Background/BlurEffect.vala"
		_clutter_paint_node_unref0 (transform_node);
#line 210 "../src/Background/BlurEffect.vala"
		_clutter_paint_node_unref0 (layer_node);
#line 974 "BlurEffect.c"
	} else {
		ClutterPaintNode* pipeline_node = NULL;
		CoglPipeline* _tmp13_;
		ClutterPipelineNode* _tmp14_;
		ClutterPaintNode* _tmp15_;
		ClutterPaintNode* _tmp16_;
		ClutterActorBox _tmp17_ = {0};
#line 236 "../src/Background/BlurEffect.vala"
		pipeline_node = NULL;
#line 238 "../src/Background/BlurEffect.vala"
		_tmp13_ = self->priv->actor_pipeline;
#line 238 "../src/Background/BlurEffect.vala"
		_tmp14_ = (ClutterPipelineNode*) clutter_pipeline_node_new (_tmp13_);
#line 238 "../src/Background/BlurEffect.vala"
		_clutter_paint_node_unref0 (pipeline_node);
#line 238 "../src/Background/BlurEffect.vala"
		pipeline_node = (ClutterPaintNode*) _tmp14_;
#line 239 "../src/Background/BlurEffect.vala"
		_tmp15_ = pipeline_node;
#line 239 "../src/Background/BlurEffect.vala"
		clutter_paint_node_add_child (node, _tmp15_);
#line 240 "../src/Background/BlurEffect.vala"
		_tmp16_ = pipeline_node;
#line 240 "../src/Background/BlurEffect.vala"
		_tmp17_.x1 = 0.0f;
#line 240 "../src/Background/BlurEffect.vala"
		_tmp17_.y1 = 0.0f;
#line 240 "../src/Background/BlurEffect.vala"
		_tmp17_.x2 = self->priv->texture_width / self->priv->downscale_factor;
#line 240 "../src/Background/BlurEffect.vala"
		_tmp17_.y2 = self->priv->texture_height / self->priv->downscale_factor;
#line 240 "../src/Background/BlurEffect.vala"
		clutter_paint_node_add_rectangle (_tmp16_, &_tmp17_);
#line 210 "../src/Background/BlurEffect.vala"
		_clutter_paint_node_unref0 (pipeline_node);
#line 1010 "BlurEffect.c"
	}
}

static void
gala_blur_effect_add_actor_node (GalaBlurEffect* self,
                                 ClutterPaintNode* node)
{
	ClutterActorNode* actor_node = NULL;
	ClutterActor* _tmp0_;
	ClutterActorNode* _tmp1_;
#line 249 "../src/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 249 "../src/Background/BlurEffect.vala"
	g_return_if_fail (node != NULL);
#line 250 "../src/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_actor;
#line 250 "../src/Background/BlurEffect.vala"
	_tmp1_ = (ClutterActorNode*) clutter_actor_node_new (_tmp0_, 255);
#line 250 "../src/Background/BlurEffect.vala"
	actor_node = _tmp1_;
#line 251 "../src/Background/BlurEffect.vala"
	clutter_paint_node_add_child (node, (ClutterPaintNode*) actor_node);
#line 249 "../src/Background/BlurEffect.vala"
	_clutter_paint_node_unref0 (actor_node);
#line 1035 "BlurEffect.c"
}

static void
gala_blur_effect_add_blurred_pipeline (GalaBlurEffect* self,
                                       ClutterPaintNode* node)
{
	ClutterPaintNode* pipeline_node = NULL;
	gfloat width = 0.0F;
	gfloat height = 0.0F;
	ClutterActor* _tmp0_;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	CoglPipeline* _tmp3_;
	ClutterPipelineNode* _tmp4_;
	ClutterPaintNode* _tmp5_;
	ClutterPaintNode* _tmp6_;
	ClutterActorBox _tmp7_ = {0};
#line 254 "../src/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/Background/BlurEffect.vala"
	g_return_if_fail (node != NULL);
#line 255 "../src/Background/BlurEffect.vala"
	pipeline_node = NULL;
#line 261 "../src/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_actor;
#line 261 "../src/Background/BlurEffect.vala"
	clutter_actor_get_size (_tmp0_, &_tmp1_, &_tmp2_);
#line 261 "../src/Background/BlurEffect.vala"
	width = _tmp1_;
#line 261 "../src/Background/BlurEffect.vala"
	height = _tmp2_;
#line 263 "../src/Background/BlurEffect.vala"
	_tmp3_ = self->priv->pipeline;
#line 263 "../src/Background/BlurEffect.vala"
	_tmp4_ = (ClutterPipelineNode*) clutter_pipeline_node_new (_tmp3_);
#line 263 "../src/Background/BlurEffect.vala"
	_clutter_paint_node_unref0 (pipeline_node);
#line 263 "../src/Background/BlurEffect.vala"
	pipeline_node = (ClutterPaintNode*) _tmp4_;
#line 264 "../src/Background/BlurEffect.vala"
	_tmp5_ = pipeline_node;
#line 264 "../src/Background/BlurEffect.vala"
	clutter_paint_node_add_child (node, _tmp5_);
#line 266 "../src/Background/BlurEffect.vala"
	_tmp6_ = pipeline_node;
#line 266 "../src/Background/BlurEffect.vala"
	_tmp7_.x1 = 0.0f;
#line 266 "../src/Background/BlurEffect.vala"
	_tmp7_.y1 = 0.0f;
#line 266 "../src/Background/BlurEffect.vala"
	_tmp7_.x2 = width;
#line 266 "../src/Background/BlurEffect.vala"
	_tmp7_.y2 = height;
#line 266 "../src/Background/BlurEffect.vala"
	clutter_paint_node_add_rectangle (_tmp6_, &_tmp7_);
#line 254 "../src/Background/BlurEffect.vala"
	_clutter_paint_node_unref0 (pipeline_node);
#line 1093 "BlurEffect.c"
}

static void
gala_blur_effect_real_paint_node (ClutterEffect* base,
                                  ClutterPaintNode* node,
                                  ClutterPaintContext* paint_context,
                                  ClutterEffectPaintFlags flags)
{
	GalaBlurEffect * self;
	gfloat _tmp0_;
#line 269 "../src/Background/BlurEffect.vala"
	self = (GalaBlurEffect*) base;
#line 269 "../src/Background/BlurEffect.vala"
	g_return_if_fail (node != NULL);
#line 269 "../src/Background/BlurEffect.vala"
	g_return_if_fail (paint_context != NULL);
#line 270 "../src/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_radius;
#line 270 "../src/Background/BlurEffect.vala"
	if (_tmp0_ <= ((gfloat) 0)) {
#line 272 "../src/Background/BlurEffect.vala"
		gala_blur_effect_add_actor_node (self, node);
#line 273 "../src/Background/BlurEffect.vala"
		return;
#line 1118 "BlurEffect.c"
	}
#line 276 "../src/Background/BlurEffect.vala"
	if (gala_blur_effect_needs_repaint (self, flags)) {
#line 1122 "BlurEffect.c"
		ClutterActorBox actor_box = {0};
		ClutterActorBox _tmp1_ = {0};
		ClutterActorBox _tmp2_;
		ClutterPaintNode* blur_node = NULL;
		ClutterPaintNode* _tmp3_;
		ClutterPaintNode* _tmp4_;
#line 277 "../src/Background/BlurEffect.vala"
		gala_blur_effect_update_actor_box (self, paint_context, &_tmp1_);
#line 277 "../src/Background/BlurEffect.vala"
		actor_box = _tmp1_;
#line 279 "../src/Background/BlurEffect.vala"
		_tmp2_ = actor_box;
#line 279 "../src/Background/BlurEffect.vala"
		if (!gala_blur_effect_update_framebuffers (self, paint_context, &_tmp2_)) {
#line 281 "../src/Background/BlurEffect.vala"
			gala_blur_effect_add_actor_node (self, node);
#line 282 "../src/Background/BlurEffect.vala"
			return;
#line 1141 "BlurEffect.c"
		}
#line 285 "../src/Background/BlurEffect.vala"
		_tmp3_ = gala_blur_effect_create_blur_nodes (self, node);
#line 285 "../src/Background/BlurEffect.vala"
		blur_node = _tmp3_;
#line 286 "../src/Background/BlurEffect.vala"
		_tmp4_ = blur_node;
#line 286 "../src/Background/BlurEffect.vala"
		gala_blur_effect_paint_actor_offscreen (self, _tmp4_, flags);
#line 276 "../src/Background/BlurEffect.vala"
		_clutter_paint_node_unref0 (blur_node);
#line 1153 "BlurEffect.c"
	} else {
#line 289 "../src/Background/BlurEffect.vala"
		gala_blur_effect_add_blurred_pipeline (self, node);
#line 1157 "BlurEffect.c"
	}
}

ClutterActor*
gala_blur_effect_get_actor (GalaBlurEffect* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 10 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 10 "../src/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_actor;
#line 10 "../src/Background/BlurEffect.vala"
	result = _tmp0_;
#line 10 "../src/Background/BlurEffect.vala"
	return result;
#line 1174 "BlurEffect.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 10 "../src/Background/BlurEffect.vala"
	return self ? g_object_ref (self) : NULL;
#line 1182 "BlurEffect.c"
}

static void
gala_blur_effect_set_actor (GalaBlurEffect* self,
                            ClutterActor* value)
{
	ClutterActor* old_value;
#line 10 "../src/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/Background/BlurEffect.vala"
	old_value = gala_blur_effect_get_actor (self);
#line 10 "../src/Background/BlurEffect.vala"
	if (old_value != value) {
#line 1196 "BlurEffect.c"
		ClutterActor* _tmp0_;
#line 10 "../src/Background/BlurEffect.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 10 "../src/Background/BlurEffect.vala"
		_g_object_unref0 (self->priv->_actor);
#line 10 "../src/Background/BlurEffect.vala"
		self->priv->_actor = _tmp0_;
#line 10 "../src/Background/BlurEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_blur_effect_properties[GALA_BLUR_EFFECT_ACTOR_PROPERTY]);
#line 1206 "BlurEffect.c"
	}
}

gfloat
gala_blur_effect_get_radius (GalaBlurEffect* self)
{
	gfloat result;
#line 11 "../src/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 11 "../src/Background/BlurEffect.vala"
	result = self->priv->_radius;
#line 11 "../src/Background/BlurEffect.vala"
	return result;
#line 1220 "BlurEffect.c"
}

static void
gala_blur_effect_set_radius (GalaBlurEffect* self,
                             gfloat value)
{
	gfloat old_value;
#line 11 "../src/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 11 "../src/Background/BlurEffect.vala"
	old_value = gala_blur_effect_get_radius (self);
#line 11 "../src/Background/BlurEffect.vala"
	if (old_value != value) {
#line 11 "../src/Background/BlurEffect.vala"
		self->priv->_radius = value;
#line 11 "../src/Background/BlurEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_blur_effect_properties[GALA_BLUR_EFFECT_RADIUS_PROPERTY]);
#line 1238 "BlurEffect.c"
	}
}

static GObject *
gala_blur_effect_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaBlurEffect * self;
	CoglContext* ctx = NULL;
	ClutterBackend* _tmp0_;
	CoglContext* _tmp1_;
	CoglContext* _tmp2_;
	CoglPipeline* _tmp3_;
	CoglPipeline* _tmp4_;
	CoglPipeline* _tmp5_;
	CoglPipeline* _tmp6_;
	CoglContext* _tmp7_;
	CoglPipeline* _tmp8_;
	CoglPipeline* _tmp9_;
	CoglPipeline* _tmp10_;
	CoglPipeline* _tmp11_;
#line 31 "../src/Background/BlurEffect.vala"
	parent_class = G_OBJECT_CLASS (gala_blur_effect_parent_class);
#line 31 "../src/Background/BlurEffect.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/Background/BlurEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_BLUR_EFFECT, GalaBlurEffect);
#line 32 "../src/Background/BlurEffect.vala"
	_tmp0_ = clutter_get_default_backend ();
#line 32 "../src/Background/BlurEffect.vala"
	_tmp1_ = clutter_backend_get_cogl_context (_tmp0_);
#line 32 "../src/Background/BlurEffect.vala"
	ctx = _tmp1_;
#line 34 "../src/Background/BlurEffect.vala"
	_tmp2_ = ctx;
#line 34 "../src/Background/BlurEffect.vala"
	_tmp3_ = cogl_pipeline_new (_tmp2_);
#line 34 "../src/Background/BlurEffect.vala"
	_cogl_object_unref0 (self->priv->actor_pipeline);
#line 34 "../src/Background/BlurEffect.vala"
	self->priv->actor_pipeline = _tmp3_;
#line 35 "../src/Background/BlurEffect.vala"
	_tmp4_ = self->priv->actor_pipeline;
#line 35 "../src/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_null_texture (_tmp4_, 0);
#line 36 "../src/Background/BlurEffect.vala"
	_tmp5_ = self->priv->actor_pipeline;
#line 36 "../src/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_filters (_tmp5_, 0, COGL_PIPELINE_FILTER_LINEAR, COGL_PIPELINE_FILTER_LINEAR);
#line 37 "../src/Background/BlurEffect.vala"
	_tmp6_ = self->priv->actor_pipeline;
#line 37 "../src/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_wrap_mode (_tmp6_, 0, COGL_PIPELINE_WRAP_MODE_CLAMP_TO_EDGE);
#line 39 "../src/Background/BlurEffect.vala"
	_tmp7_ = ctx;
#line 39 "../src/Background/BlurEffect.vala"
	_tmp8_ = cogl_pipeline_new (_tmp7_);
#line 39 "../src/Background/BlurEffect.vala"
	_cogl_object_unref0 (self->priv->pipeline);
#line 39 "../src/Background/BlurEffect.vala"
	self->priv->pipeline = _tmp8_;
#line 40 "../src/Background/BlurEffect.vala"
	_tmp9_ = self->priv->pipeline;
#line 40 "../src/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_null_texture (_tmp9_, 0);
#line 41 "../src/Background/BlurEffect.vala"
	_tmp10_ = self->priv->pipeline;
#line 41 "../src/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_filters (_tmp10_, 0, COGL_PIPELINE_FILTER_LINEAR, COGL_PIPELINE_FILTER_LINEAR);
#line 42 "../src/Background/BlurEffect.vala"
	_tmp11_ = self->priv->pipeline;
#line 42 "../src/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_wrap_mode (_tmp11_, 0, COGL_PIPELINE_WRAP_MODE_CLAMP_TO_EDGE);
#line 31 "../src/Background/BlurEffect.vala"
	return obj;
#line 1317 "BlurEffect.c"
}

static void
gala_blur_effect_class_init (GalaBlurEffectClass * klass,
                             gpointer klass_data)
{
#line 6 "../src/Background/BlurEffect.vala"
	gala_blur_effect_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/Background/BlurEffect.vala"
	g_type_class_adjust_private_offset (klass, &GalaBlurEffect_private_offset);
#line 6 "../src/Background/BlurEffect.vala"
	((ClutterEffectClass *) klass)->paint_node = (void (*) (ClutterEffect*, ClutterPaintNode*, ClutterPaintContext*, ClutterEffectPaintFlags)) gala_blur_effect_real_paint_node;
#line 6 "../src/Background/BlurEffect.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_blur_effect_get_property;
#line 6 "../src/Background/BlurEffect.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_blur_effect_set_property;
#line 6 "../src/Background/BlurEffect.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_blur_effect_constructor;
#line 6 "../src/Background/BlurEffect.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_blur_effect_finalize;
#line 6 "../src/Background/BlurEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BLUR_EFFECT_ACTOR_PROPERTY, gala_blur_effect_properties[GALA_BLUR_EFFECT_ACTOR_PROPERTY] = g_param_spec_object ("actor", "actor", "actor", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6 "../src/Background/BlurEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BLUR_EFFECT_RADIUS_PROPERTY, gala_blur_effect_properties[GALA_BLUR_EFFECT_RADIUS_PROPERTY] = g_param_spec_float ("radius", "radius", "radius", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1342 "BlurEffect.c"
}

static void
gala_blur_effect_instance_init (GalaBlurEffect * self,
                                gpointer klass)
{
#line 6 "../src/Background/BlurEffect.vala"
	self->priv = gala_blur_effect_get_instance_private (self);
#line 13 "../src/Background/BlurEffect.vala"
	self->priv->actor_painted = FALSE;
#line 14 "../src/Background/BlurEffect.vala"
	self->priv->blur_applied = FALSE;
#line 1355 "BlurEffect.c"
}

static void
gala_blur_effect_finalize (GObject * obj)
{
	GalaBlurEffect * self;
#line 6 "../src/Background/BlurEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_BLUR_EFFECT, GalaBlurEffect);
#line 10 "../src/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->_actor);
#line 19 "../src/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->actor_framebuffer);
#line 20 "../src/Background/BlurEffect.vala"
	_cogl_object_unref0 (self->priv->actor_pipeline);
#line 21 "../src/Background/BlurEffect.vala"
	_cogl_object_unref0 (self->priv->actor_texture);
#line 23 "../src/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->framebuffer);
#line 24 "../src/Background/BlurEffect.vala"
	_cogl_object_unref0 (self->priv->pipeline);
#line 25 "../src/Background/BlurEffect.vala"
	_cogl_object_unref0 (self->priv->texture);
#line 6 "../src/Background/BlurEffect.vala"
	G_OBJECT_CLASS (gala_blur_effect_parent_class)->finalize (obj);
#line 1380 "BlurEffect.c"
}

 G_GNUC_NO_INLINE static GType
gala_blur_effect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaBlurEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_blur_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaBlurEffect), 0, (GInstanceInitFunc) gala_blur_effect_instance_init, NULL };
	GType gala_blur_effect_type_id;
	gala_blur_effect_type_id = g_type_register_static (clutter_effect_get_type (), "GalaBlurEffect", &g_define_type_info, 0);
	GalaBlurEffect_private_offset = g_type_add_instance_private (gala_blur_effect_type_id, sizeof (GalaBlurEffectPrivate));
	return gala_blur_effect_type_id;
}

GType
gala_blur_effect_get_type (void)
{
	static gsize gala_blur_effect_type_id__once = 0;
	if (g_once_init_enter (&gala_blur_effect_type_id__once)) {
		GType gala_blur_effect_type_id;
		gala_blur_effect_type_id = gala_blur_effect_get_type_once ();
		g_once_init_leave (&gala_blur_effect_type_id__once, gala_blur_effect_type_id);
	}
	return gala_blur_effect_type_id__once;
}

static void
_vala_gala_blur_effect_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	GalaBlurEffect * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_BLUR_EFFECT, GalaBlurEffect);
#line 6 "../src/Background/BlurEffect.vala"
	switch (property_id) {
#line 6 "../src/Background/BlurEffect.vala"
		case GALA_BLUR_EFFECT_ACTOR_PROPERTY:
#line 6 "../src/Background/BlurEffect.vala"
		g_value_set_object (value, gala_blur_effect_get_actor (self));
#line 6 "../src/Background/BlurEffect.vala"
		break;
#line 6 "../src/Background/BlurEffect.vala"
		case GALA_BLUR_EFFECT_RADIUS_PROPERTY:
#line 6 "../src/Background/BlurEffect.vala"
		g_value_set_float (value, gala_blur_effect_get_radius (self));
#line 6 "../src/Background/BlurEffect.vala"
		break;
#line 1427 "BlurEffect.c"
		default:
#line 6 "../src/Background/BlurEffect.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Background/BlurEffect.vala"
		break;
#line 1433 "BlurEffect.c"
	}
}

static void
_vala_gala_blur_effect_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	GalaBlurEffect * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_BLUR_EFFECT, GalaBlurEffect);
#line 6 "../src/Background/BlurEffect.vala"
	switch (property_id) {
#line 6 "../src/Background/BlurEffect.vala"
		case GALA_BLUR_EFFECT_ACTOR_PROPERTY:
#line 6 "../src/Background/BlurEffect.vala"
		gala_blur_effect_set_actor (self, g_value_get_object (value));
#line 6 "../src/Background/BlurEffect.vala"
		break;
#line 6 "../src/Background/BlurEffect.vala"
		case GALA_BLUR_EFFECT_RADIUS_PROPERTY:
#line 6 "../src/Background/BlurEffect.vala"
		gala_blur_effect_set_radius (self, g_value_get_float (value));
#line 6 "../src/Background/BlurEffect.vala"
		break;
#line 1459 "BlurEffect.c"
		default:
#line 6 "../src/Background/BlurEffect.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Background/BlurEffect.vala"
		break;
#line 1465 "BlurEffect.c"
	}
}

