/* HideTracker.c generated by valac 0.56.17, the Vala compiler
 * generated from HideTracker.vala, do not modify */

/*
 * Copyright 2024 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <glib-object.h>
#include <meta/display.h>
#include "pantheon-desktop-shell-server-protocol.h"
#include <glib.h>
#include <meta/window.h>
#include <meta/meta-cursor-tracker.h>
#include <graphene-gobject.h>
#include <mtk/mtk.h>
#include <float.h>
#include <math.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>

#define GALA_HIDE_TRACKER_UPDATE_TIMEOUT ((guint) 200)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_HIDE_TRACKER (gala_hide_tracker_get_type ())
#define GALA_HIDE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_HIDE_TRACKER, GalaHideTracker))
#define GALA_HIDE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_HIDE_TRACKER, GalaHideTrackerClass))
#define GALA_IS_HIDE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_HIDE_TRACKER))
#define GALA_IS_HIDE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_HIDE_TRACKER))
#define GALA_HIDE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_HIDE_TRACKER, GalaHideTrackerClass))

typedef struct _GalaHideTracker GalaHideTracker;
typedef struct _GalaHideTrackerClass GalaHideTrackerClass;
typedef struct _GalaHideTrackerPrivate GalaHideTrackerPrivate;

#define GALA_TYPE_PANEL_WINDOW (gala_panel_window_get_type ())
#define GALA_PANEL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_PANEL_WINDOW, GalaPanelWindow))
#define GALA_PANEL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_PANEL_WINDOW, GalaPanelWindowClass))
#define GALA_IS_PANEL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_PANEL_WINDOW))
#define GALA_IS_PANEL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_PANEL_WINDOW))
#define GALA_PANEL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_PANEL_WINDOW, GalaPanelWindowClass))

typedef struct _GalaPanelWindow GalaPanelWindow;
typedef struct _GalaPanelWindowClass GalaPanelWindowClass;
enum  {
	GALA_HIDE_TRACKER_0_PROPERTY,
	GALA_HIDE_TRACKER_DISPLAY_PROPERTY,
	GALA_HIDE_TRACKER_PANEL_PROPERTY,
	GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY,
	GALA_HIDE_TRACKER_NUM_PROPERTIES
};
static GParamSpec* gala_hide_tracker_properties[GALA_HIDE_TRACKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block60Data Block60Data;
enum  {
	GALA_HIDE_TRACKER_HIDE_SIGNAL,
	GALA_HIDE_TRACKER_SHOW_SIGNAL,
	GALA_HIDE_TRACKER_NUM_SIGNALS
};
static guint gala_hide_tracker_signals[GALA_HIDE_TRACKER_NUM_SIGNALS] = {0};

struct _GalaHideTracker {
	GObject parent_instance;
	GalaHideTrackerPrivate * priv;
};

struct _GalaHideTrackerClass {
	GObjectClass parent_class;
};

struct _GalaHideTrackerPrivate {
	MetaDisplay* _display;
	GalaPanelWindow* _panel;
	enum io_elementary_pantheon_panel_v1_hide_mode _hide_mode;
	gboolean hovered;
	gboolean overlap;
	gboolean focus_overlap;
	gboolean focus_maximized_overlap;
	MetaWindow* current_focus_window;
	guint update_timeout_id;
};

struct _Block60Data {
	int _ref_count_;
	GalaHideTracker* self;
	gboolean has_transients;
};

static gint GalaHideTracker_private_offset;
static gpointer gala_hide_tracker_parent_class = NULL;

VALA_EXTERN GType gala_hide_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaHideTracker, g_object_unref)
VALA_EXTERN GType gala_panel_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPanelWindow, g_object_unref)
VALA_EXTERN GalaHideTracker* gala_hide_tracker_new (MetaDisplay* display,
                                        GalaPanelWindow* panel);
VALA_EXTERN GalaHideTracker* gala_hide_tracker_construct (GType object_type,
                                              MetaDisplay* display,
                                              GalaPanelWindow* panel);
static gboolean gala_hide_tracker_window_has_pointer (GalaHideTracker* self);
VALA_EXTERN MetaDisplay* gala_hide_tracker_get_display (GalaHideTracker* self);
VALA_EXTERN GalaPanelWindow* gala_hide_tracker_get_panel (GalaHideTracker* self);
VALA_EXTERN void gala_panel_window_get_custom_window_rect (GalaPanelWindow* self,
                                               MtkRectangle* result);
static void gala_hide_tracker_track_focus_window (GalaHideTracker* self,
                                           MetaWindow* window);
VALA_EXTERN void gala_hide_tracker_schedule_update (GalaHideTracker* self);
static void _gala_hide_tracker_schedule_update_meta_window_position_changed (MetaWindow* _sender,
                                                                      gpointer self);
static void _gala_hide_tracker_schedule_update_meta_window_size_changed (MetaWindow* _sender,
                                                                  gpointer self);
static void gala_hide_tracker_untrack_focus_window (GalaHideTracker* self,
                                             MetaWindow* window);
static gboolean __lambda103_ (GalaHideTracker* self);
static void gala_hide_tracker_update_overlap (GalaHideTracker* self);
static gboolean ___lambda103__gsource_func (gpointer self);
VALA_EXTERN MetaWindow* gala_panel_window_get_window (GalaPanelWindow* self);
static void gala_hide_tracker_update_hidden (GalaHideTracker* self);
VALA_EXTERN enum io_elementary_pantheon_panel_v1_hide_mode gala_hide_tracker_get_hide_mode (GalaHideTracker* self);
static void gala_hide_tracker_toggle_display (GalaHideTracker* self,
                                       gboolean should_hide);
static Block60Data* block60_data_ref (Block60Data* _data60_);
static void block60_data_unref (void * _userdata_);
static gboolean ___lambda104_ (Block60Data* _data60_);
static gboolean ____lambda104__meta_window_foreach_func (MetaWindow* window,
                                                  gpointer self);
static void gala_hide_tracker_set_display (GalaHideTracker* self,
                                    MetaDisplay* value);
static void gala_hide_tracker_set_panel (GalaHideTracker* self,
                                  GalaPanelWindow* value);
VALA_EXTERN void gala_hide_tracker_set_hide_mode (GalaHideTracker* self,
                                      enum io_elementary_pantheon_panel_v1_hide_mode value);
static GObject * gala_hide_tracker_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _gala_hide_tracker___lambda105_ (GalaHideTracker* self);
static void __gala_hide_tracker___lambda105__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void _gala_hide_tracker___lambda106_ (GalaHideTracker* self,
                                      MetaWindow* window);
static void _gala_hide_tracker_schedule_update_meta_window_unmanaged (MetaWindow* _sender,
                                                               gpointer self);
static void __gala_hide_tracker___lambda106__meta_display_window_created (MetaDisplay* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self);
static void _gala_hide_tracker___lambda107_ (GalaHideTracker* self);
static void __gala_hide_tracker___lambda107__meta_cursor_tracker_position_invalidated (MetaCursorTracker* _sender,
                                                                                gpointer self);
static void _gala_hide_tracker_schedule_update_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                         gpointer self);
static void gala_hide_tracker_finalize (GObject * obj);
static GType gala_hide_tracker_get_type_once (void);
static void _vala_gala_hide_tracker_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_gala_hide_tracker_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
gala_hide_tracker_get_instance_private (GalaHideTracker* self)
{
	return G_STRUCT_MEMBER_P (self, GalaHideTracker_private_offset);
}

GalaHideTracker*
gala_hide_tracker_construct (GType object_type,
                             MetaDisplay* display,
                             GalaPanelWindow* panel)
{
	GalaHideTracker * self = NULL;
#line 28 "../src/ShellClients/HideTracker.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 28 "../src/ShellClients/HideTracker.vala"
	g_return_val_if_fail (panel != NULL, NULL);
#line 29 "../src/ShellClients/HideTracker.vala"
	self = (GalaHideTracker*) g_object_new (object_type, "display", display, "panel", panel, NULL);
#line 28 "../src/ShellClients/HideTracker.vala"
	return self;
#line 203 "HideTracker.c"
}

GalaHideTracker*
gala_hide_tracker_new (MetaDisplay* display,
                       GalaPanelWindow* panel)
{
#line 28 "../src/ShellClients/HideTracker.vala"
	return gala_hide_tracker_construct (GALA_TYPE_HIDE_TRACKER, display, panel);
#line 212 "HideTracker.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 67 "../src/ShellClients/HideTracker.vala"
	return self ? g_object_ref (self) : NULL;
#line 220 "HideTracker.c"
}

static gboolean
gala_hide_tracker_window_has_pointer (GalaHideTracker* self)
{
	MetaCursorTracker* cursor_tracker = NULL;
	MetaDisplay* _tmp0_;
	MetaCursorTracker* _tmp1_;
	MetaCursorTracker* _tmp2_;
	graphene_point_t pointer_pos = {0};
	graphene_point_t _tmp3_ = {0};
	MtkRectangle window_rect = {0};
	GalaPanelWindow* _tmp4_;
	MtkRectangle _tmp5_ = {0};
	graphene_rect_t graphene_window_rect = {0};
	MtkRectangle _tmp6_;
	MtkRectangle _tmp7_;
	MtkRectangle _tmp8_;
	MtkRectangle _tmp9_;
	graphene_rect_t _tmp10_ = {0};
	graphene_point_t _tmp11_;
	gboolean result;
#line 66 "../src/ShellClients/HideTracker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 67 "../src/ShellClients/HideTracker.vala"
	_tmp0_ = self->priv->_display;
#line 67 "../src/ShellClients/HideTracker.vala"
	_tmp1_ = meta_cursor_tracker_get_for_display (_tmp0_);
#line 67 "../src/ShellClients/HideTracker.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 67 "../src/ShellClients/HideTracker.vala"
	cursor_tracker = _tmp2_;
#line 69 "../src/ShellClients/HideTracker.vala"
	meta_cursor_tracker_get_pointer (cursor_tracker, &_tmp3_, NULL);
#line 69 "../src/ShellClients/HideTracker.vala"
	pointer_pos = _tmp3_;
#line 71 "../src/ShellClients/HideTracker.vala"
	_tmp4_ = self->priv->_panel;
#line 71 "../src/ShellClients/HideTracker.vala"
	gala_panel_window_get_custom_window_rect (_tmp4_, &_tmp5_);
#line 71 "../src/ShellClients/HideTracker.vala"
	window_rect = _tmp5_;
#line 72 "../src/ShellClients/HideTracker.vala"
	_tmp6_ = window_rect;
#line 72 "../src/ShellClients/HideTracker.vala"
	_tmp7_ = window_rect;
#line 72 "../src/ShellClients/HideTracker.vala"
	_tmp8_ = window_rect;
#line 72 "../src/ShellClients/HideTracker.vala"
	_tmp9_ = window_rect;
#line 72 "../src/ShellClients/HideTracker.vala"
	_tmp10_.origin = (graphene_point_t) {(gfloat) _tmp6_.x, (gfloat) _tmp7_.y};
#line 72 "../src/ShellClients/HideTracker.vala"
	_tmp10_.size = (graphene_size_t) {(gfloat) _tmp8_.width, (gfloat) _tmp9_.height};
#line 72 "../src/ShellClients/HideTracker.vala"
	graphene_window_rect = _tmp10_;
#line 82 "../src/ShellClients/HideTracker.vala"
	_tmp11_ = pointer_pos;
#line 82 "../src/ShellClients/HideTracker.vala"
	result = graphene_rect_contains_point (&graphene_window_rect, &_tmp11_);
#line 82 "../src/ShellClients/HideTracker.vala"
	_g_object_unref0 (cursor_tracker);
#line 82 "../src/ShellClients/HideTracker.vala"
	return result;
#line 285 "HideTracker.c"
}

static void
_gala_hide_tracker_schedule_update_meta_window_position_changed (MetaWindow* _sender,
                                                                 gpointer self)
{
#line 90 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_schedule_update ((GalaHideTracker*) self);
#line 294 "HideTracker.c"
}

static void
_gala_hide_tracker_schedule_update_meta_window_size_changed (MetaWindow* _sender,
                                                             gpointer self)
{
#line 91 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_schedule_update ((GalaHideTracker*) self);
#line 303 "HideTracker.c"
}

static void
gala_hide_tracker_track_focus_window (GalaHideTracker* self,
                                      MetaWindow* window)
{
#line 85 "../src/ShellClients/HideTracker.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/ShellClients/HideTracker.vala"
	if (window == NULL) {
#line 87 "../src/ShellClients/HideTracker.vala"
		return;
#line 316 "HideTracker.c"
	}
#line 90 "../src/ShellClients/HideTracker.vala"
	g_signal_connect_object (window, "position-changed", (GCallback) _gala_hide_tracker_schedule_update_meta_window_position_changed, self, 0);
#line 91 "../src/ShellClients/HideTracker.vala"
	g_signal_connect_object (window, "size-changed", (GCallback) _gala_hide_tracker_schedule_update_meta_window_size_changed, self, 0);
#line 92 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_schedule_update (self);
#line 324 "HideTracker.c"
}

static void
gala_hide_tracker_untrack_focus_window (GalaHideTracker* self,
                                        MetaWindow* window)
{
	guint _tmp0_;
	guint _tmp1_;
#line 95 "../src/ShellClients/HideTracker.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/ShellClients/HideTracker.vala"
	if (window == NULL) {
#line 97 "../src/ShellClients/HideTracker.vala"
		return;
#line 339 "HideTracker.c"
	}
#line 100 "../src/ShellClients/HideTracker.vala"
	g_signal_parse_name ("position-changed", meta_window_get_type (), &_tmp0_, NULL, FALSE);
#line 100 "../src/ShellClients/HideTracker.vala"
	g_signal_handlers_disconnect_matched (window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _gala_hide_tracker_schedule_update_meta_window_position_changed, self);
#line 101 "../src/ShellClients/HideTracker.vala"
	g_signal_parse_name ("size-changed", meta_window_get_type (), &_tmp1_, NULL, FALSE);
#line 101 "../src/ShellClients/HideTracker.vala"
	g_signal_handlers_disconnect_matched (window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_hide_tracker_schedule_update_meta_window_size_changed, self);
#line 102 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_schedule_update (self);
#line 351 "HideTracker.c"
}

static gboolean
__lambda103_ (GalaHideTracker* self)
{
	gboolean result;
#line 111 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_update_overlap (self);
#line 112 "../src/ShellClients/HideTracker.vala"
	self->priv->update_timeout_id = (guint) 0;
#line 113 "../src/ShellClients/HideTracker.vala"
	result = G_SOURCE_REMOVE;
#line 113 "../src/ShellClients/HideTracker.vala"
	return result;
#line 366 "HideTracker.c"
}

static gboolean
___lambda103__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda103_ ((GalaHideTracker*) self);
#line 110 "../src/ShellClients/HideTracker.vala"
	return result;
#line 376 "HideTracker.c"
}

void
gala_hide_tracker_schedule_update (GalaHideTracker* self)
{
#line 105 "../src/ShellClients/HideTracker.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/ShellClients/HideTracker.vala"
	if (self->priv->update_timeout_id != ((guint) 0)) {
#line 107 "../src/ShellClients/HideTracker.vala"
		return;
#line 388 "HideTracker.c"
	}
#line 110 "../src/ShellClients/HideTracker.vala"
	self->priv->update_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, GALA_HIDE_TRACKER_UPDATE_TIMEOUT, ___lambda103__gsource_func, g_object_ref (self), g_object_unref);
#line 392 "HideTracker.c"
}

static void
gala_hide_tracker_update_overlap (GalaHideTracker* self)
{
	MetaDisplay* _tmp0_;
	MetaWorkspaceManager* _tmp1_;
	MetaWorkspace* _tmp2_;
	GList* _tmp3_;
#line 117 "../src/ShellClients/HideTracker.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/ShellClients/HideTracker.vala"
	self->priv->overlap = FALSE;
#line 119 "../src/ShellClients/HideTracker.vala"
	self->priv->focus_overlap = FALSE;
#line 120 "../src/ShellClients/HideTracker.vala"
	self->priv->focus_maximized_overlap = FALSE;
#line 122 "../src/ShellClients/HideTracker.vala"
	_tmp0_ = self->priv->_display;
#line 122 "../src/ShellClients/HideTracker.vala"
	_tmp1_ = meta_display_get_workspace_manager (_tmp0_);
#line 122 "../src/ShellClients/HideTracker.vala"
	_tmp2_ = meta_workspace_manager_get_active_workspace (_tmp1_);
#line 122 "../src/ShellClients/HideTracker.vala"
	_tmp3_ = meta_workspace_list_windows (_tmp2_);
#line 418 "HideTracker.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 122 "../src/ShellClients/HideTracker.vala"
		window_collection = _tmp3_;
#line 122 "../src/ShellClients/HideTracker.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 426 "HideTracker.c"
			MetaWindow* window = NULL;
#line 122 "../src/ShellClients/HideTracker.vala"
			window = (MetaWindow*) window_it->data;
#line 430 "HideTracker.c"
			{
				MetaWindow* _tmp4_;
				GalaPanelWindow* _tmp5_;
				MetaWindow* _tmp6_;
				MetaWindow* _tmp7_;
				MetaWindow* _tmp8_;
				gboolean _tmp9_;
				gboolean _tmp10_;
				MetaWindowType type = 0;
				MetaWindow* _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
				GalaPanelWindow* _tmp15_;
				MtkRectangle _tmp16_ = {0};
				MetaWindow* _tmp17_;
				MtkRectangle _tmp18_ = {0};
				MetaWindow* _tmp19_;
				MetaDisplay* _tmp20_;
				MetaWindow* _tmp21_;
				MetaWindow* _tmp22_;
				MetaWindow* _tmp23_;
#line 123 "../src/ShellClients/HideTracker.vala"
				_tmp4_ = window;
#line 123 "../src/ShellClients/HideTracker.vala"
				_tmp5_ = self->priv->_panel;
#line 123 "../src/ShellClients/HideTracker.vala"
				_tmp6_ = gala_panel_window_get_window (_tmp5_);
#line 123 "../src/ShellClients/HideTracker.vala"
				_tmp7_ = _tmp6_;
#line 123 "../src/ShellClients/HideTracker.vala"
				if (_tmp4_ == _tmp7_) {
#line 124 "../src/ShellClients/HideTracker.vala"
					continue;
#line 465 "HideTracker.c"
				}
#line 127 "../src/ShellClients/HideTracker.vala"
				_tmp8_ = window;
#line 127 "../src/ShellClients/HideTracker.vala"
				g_object_get (_tmp8_, "minimized", &_tmp9_, NULL);
#line 127 "../src/ShellClients/HideTracker.vala"
				_tmp10_ = _tmp9_;
#line 127 "../src/ShellClients/HideTracker.vala"
				if (_tmp10_) {
#line 128 "../src/ShellClients/HideTracker.vala"
					continue;
#line 477 "HideTracker.c"
				}
#line 131 "../src/ShellClients/HideTracker.vala"
				_tmp11_ = window;
#line 131 "../src/ShellClients/HideTracker.vala"
				type = meta_window_get_window_type (_tmp11_);
#line 132 "../src/ShellClients/HideTracker.vala"
				if (type == META_WINDOW_DESKTOP) {
#line 132 "../src/ShellClients/HideTracker.vala"
					_tmp14_ = TRUE;
#line 487 "HideTracker.c"
				} else {
#line 132 "../src/ShellClients/HideTracker.vala"
					_tmp14_ = type == META_WINDOW_DOCK;
#line 491 "HideTracker.c"
				}
#line 132 "../src/ShellClients/HideTracker.vala"
				if (_tmp14_) {
#line 132 "../src/ShellClients/HideTracker.vala"
					_tmp13_ = TRUE;
#line 497 "HideTracker.c"
				} else {
#line 132 "../src/ShellClients/HideTracker.vala"
					_tmp13_ = type == META_WINDOW_MENU;
#line 501 "HideTracker.c"
				}
#line 132 "../src/ShellClients/HideTracker.vala"
				if (_tmp13_) {
#line 132 "../src/ShellClients/HideTracker.vala"
					_tmp12_ = TRUE;
#line 507 "HideTracker.c"
				} else {
#line 132 "../src/ShellClients/HideTracker.vala"
					_tmp12_ = type == META_WINDOW_SPLASHSCREEN;
#line 511 "HideTracker.c"
				}
#line 132 "../src/ShellClients/HideTracker.vala"
				if (_tmp12_) {
#line 133 "../src/ShellClients/HideTracker.vala"
					continue;
#line 517 "HideTracker.c"
				}
#line 136 "../src/ShellClients/HideTracker.vala"
				_tmp15_ = self->priv->_panel;
#line 136 "../src/ShellClients/HideTracker.vala"
				gala_panel_window_get_custom_window_rect (_tmp15_, &_tmp16_);
#line 136 "../src/ShellClients/HideTracker.vala"
				_tmp17_ = window;
#line 136 "../src/ShellClients/HideTracker.vala"
				meta_window_get_frame_rect (_tmp17_, &_tmp18_);
#line 136 "../src/ShellClients/HideTracker.vala"
				if (!mtk_rectangle_overlap (&_tmp16_, &_tmp18_)) {
#line 137 "../src/ShellClients/HideTracker.vala"
					continue;
#line 531 "HideTracker.c"
				}
#line 140 "../src/ShellClients/HideTracker.vala"
				self->priv->overlap = TRUE;
#line 142 "../src/ShellClients/HideTracker.vala"
				_tmp19_ = window;
#line 142 "../src/ShellClients/HideTracker.vala"
				_tmp20_ = self->priv->_display;
#line 142 "../src/ShellClients/HideTracker.vala"
				_tmp21_ = meta_display_get_focus_window (_tmp20_);
#line 142 "../src/ShellClients/HideTracker.vala"
				_tmp22_ = _tmp21_;
#line 142 "../src/ShellClients/HideTracker.vala"
				if (_tmp19_ != _tmp22_) {
#line 143 "../src/ShellClients/HideTracker.vala"
					continue;
#line 547 "HideTracker.c"
				}
#line 146 "../src/ShellClients/HideTracker.vala"
				self->priv->focus_overlap = TRUE;
#line 147 "../src/ShellClients/HideTracker.vala"
				_tmp23_ = window;
#line 147 "../src/ShellClients/HideTracker.vala"
				self->priv->focus_maximized_overlap = meta_window_get_maximized (_tmp23_) == META_MAXIMIZE_BOTH;
#line 555 "HideTracker.c"
			}
		}
#line 122 "../src/ShellClients/HideTracker.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 560 "HideTracker.c"
	}
#line 150 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_update_hidden (self);
#line 564 "HideTracker.c"
}

static void
gala_hide_tracker_update_hidden (GalaHideTracker* self)
{
	enum io_elementary_pantheon_panel_v1_hide_mode _tmp0_;
#line 153 "../src/ShellClients/HideTracker.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/ShellClients/HideTracker.vala"
	_tmp0_ = self->priv->_hide_mode;
#line 154 "../src/ShellClients/HideTracker.vala"
	switch (_tmp0_) {
#line 154 "../src/ShellClients/HideTracker.vala"
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_NEVER:
#line 579 "HideTracker.c"
		{
#line 156 "../src/ShellClients/HideTracker.vala"
			gala_hide_tracker_toggle_display (self, FALSE);
#line 157 "../src/ShellClients/HideTracker.vala"
			break;
#line 585 "HideTracker.c"
		}
#line 154 "../src/ShellClients/HideTracker.vala"
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_MAXIMIZED_FOCUS_WINDOW:
#line 589 "HideTracker.c"
		{
#line 160 "../src/ShellClients/HideTracker.vala"
			gala_hide_tracker_toggle_display (self, self->priv->focus_maximized_overlap);
#line 161 "../src/ShellClients/HideTracker.vala"
			break;
#line 595 "HideTracker.c"
		}
#line 154 "../src/ShellClients/HideTracker.vala"
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_OVERLAPPING_FOCUS_WINDOW:
#line 599 "HideTracker.c"
		{
#line 164 "../src/ShellClients/HideTracker.vala"
			gala_hide_tracker_toggle_display (self, self->priv->focus_overlap);
#line 165 "../src/ShellClients/HideTracker.vala"
			break;
#line 605 "HideTracker.c"
		}
#line 154 "../src/ShellClients/HideTracker.vala"
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_OVERLAPPING_WINDOW:
#line 609 "HideTracker.c"
		{
#line 168 "../src/ShellClients/HideTracker.vala"
			gala_hide_tracker_toggle_display (self, self->priv->overlap);
#line 169 "../src/ShellClients/HideTracker.vala"
			break;
#line 615 "HideTracker.c"
		}
#line 154 "../src/ShellClients/HideTracker.vala"
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_ALWAYS:
#line 619 "HideTracker.c"
		{
#line 172 "../src/ShellClients/HideTracker.vala"
			gala_hide_tracker_toggle_display (self, TRUE);
#line 173 "../src/ShellClients/HideTracker.vala"
			break;
#line 625 "HideTracker.c"
		}
		default:
#line 154 "../src/ShellClients/HideTracker.vala"
		break;
#line 630 "HideTracker.c"
	}
}

static Block60Data*
block60_data_ref (Block60Data* _data60_)
{
#line 184 "../src/ShellClients/HideTracker.vala"
	g_atomic_int_inc (&_data60_->_ref_count_);
#line 184 "../src/ShellClients/HideTracker.vala"
	return _data60_;
#line 641 "HideTracker.c"
}

static void
block60_data_unref (void * _userdata_)
{
	Block60Data* _data60_;
	_data60_ = (Block60Data*) _userdata_;
#line 184 "../src/ShellClients/HideTracker.vala"
	if (g_atomic_int_dec_and_test (&_data60_->_ref_count_)) {
#line 651 "HideTracker.c"
		GalaHideTracker* self;
#line 184 "../src/ShellClients/HideTracker.vala"
		self = _data60_->self;
#line 184 "../src/ShellClients/HideTracker.vala"
		_g_object_unref0 (self);
#line 184 "../src/ShellClients/HideTracker.vala"
		g_slice_free (Block60Data, _data60_);
#line 659 "HideTracker.c"
	}
}

static gboolean
___lambda104_ (Block60Data* _data60_)
{
	GalaHideTracker* self;
	gboolean result;
#line 187 "../src/ShellClients/HideTracker.vala"
	self = _data60_->self;
#line 188 "../src/ShellClients/HideTracker.vala"
	_data60_->has_transients = TRUE;
#line 189 "../src/ShellClients/HideTracker.vala"
	result = FALSE;
#line 189 "../src/ShellClients/HideTracker.vala"
	return result;
#line 676 "HideTracker.c"
}

static gboolean
____lambda104__meta_window_foreach_func (MetaWindow* window,
                                         gpointer self)
{
	gboolean result;
	result = ___lambda104_ (self);
#line 187 "../src/ShellClients/HideTracker.vala"
	return result;
#line 687 "HideTracker.c"
}

static void
gala_hide_tracker_toggle_display (GalaHideTracker* self,
                                  gboolean should_hide)
{
	GalaPanelWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 177 "../src/ShellClients/HideTracker.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/ShellClients/HideTracker.vala"
	_tmp0_ = self->priv->_panel;
#line 179 "../src/ShellClients/HideTracker.vala"
	_tmp1_ = gala_panel_window_get_window (_tmp0_);
#line 179 "../src/ShellClients/HideTracker.vala"
	_tmp2_ = _tmp1_;
#line 179 "../src/ShellClients/HideTracker.vala"
	self->priv->hovered = meta_window_has_pointer (_tmp2_);
#line 184 "../src/ShellClients/HideTracker.vala"
	if (should_hide) {
#line 184 "../src/ShellClients/HideTracker.vala"
		_tmp3_ = !self->priv->hovered;
#line 712 "HideTracker.c"
	} else {
#line 184 "../src/ShellClients/HideTracker.vala"
		_tmp3_ = FALSE;
#line 716 "HideTracker.c"
	}
#line 184 "../src/ShellClients/HideTracker.vala"
	if (_tmp3_) {
#line 720 "HideTracker.c"
		Block60Data* _data60_;
		GalaPanelWindow* _tmp4_;
		MetaWindow* _tmp5_;
		MetaWindow* _tmp6_;
#line 184 "../src/ShellClients/HideTracker.vala"
		_data60_ = g_slice_new0 (Block60Data);
#line 184 "../src/ShellClients/HideTracker.vala"
		_data60_->_ref_count_ = 1;
#line 184 "../src/ShellClients/HideTracker.vala"
		_data60_->self = g_object_ref (self);
#line 186 "../src/ShellClients/HideTracker.vala"
		_data60_->has_transients = FALSE;
#line 187 "../src/ShellClients/HideTracker.vala"
		_tmp4_ = self->priv->_panel;
#line 187 "../src/ShellClients/HideTracker.vala"
		_tmp5_ = gala_panel_window_get_window (_tmp4_);
#line 187 "../src/ShellClients/HideTracker.vala"
		_tmp6_ = _tmp5_;
#line 187 "../src/ShellClients/HideTracker.vala"
		meta_window_foreach_transient (_tmp6_, ____lambda104__meta_window_foreach_func, _data60_);
#line 192 "../src/ShellClients/HideTracker.vala"
		if (_data60_->has_transients) {
#line 193 "../src/ShellClients/HideTracker.vala"
			block60_data_unref (_data60_);
#line 193 "../src/ShellClients/HideTracker.vala"
			_data60_ = NULL;
#line 193 "../src/ShellClients/HideTracker.vala"
			return;
#line 749 "HideTracker.c"
		}
#line 196 "../src/ShellClients/HideTracker.vala"
		g_signal_emit (self, gala_hide_tracker_signals[GALA_HIDE_TRACKER_HIDE_SIGNAL], 0);
#line 184 "../src/ShellClients/HideTracker.vala"
		block60_data_unref (_data60_);
#line 184 "../src/ShellClients/HideTracker.vala"
		_data60_ = NULL;
#line 757 "HideTracker.c"
	} else {
#line 198 "../src/ShellClients/HideTracker.vala"
		g_signal_emit (self, gala_hide_tracker_signals[GALA_HIDE_TRACKER_SHOW_SIGNAL], 0);
#line 761 "HideTracker.c"
	}
}

MetaDisplay*
gala_hide_tracker_get_display (GalaHideTracker* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
#line 14 "../src/ShellClients/HideTracker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 14 "../src/ShellClients/HideTracker.vala"
	_tmp0_ = self->priv->_display;
#line 14 "../src/ShellClients/HideTracker.vala"
	result = _tmp0_;
#line 14 "../src/ShellClients/HideTracker.vala"
	return result;
#line 778 "HideTracker.c"
}

static void
gala_hide_tracker_set_display (GalaHideTracker* self,
                               MetaDisplay* value)
{
	MetaDisplay* old_value;
#line 14 "../src/ShellClients/HideTracker.vala"
	g_return_if_fail (self != NULL);
#line 14 "../src/ShellClients/HideTracker.vala"
	old_value = gala_hide_tracker_get_display (self);
#line 14 "../src/ShellClients/HideTracker.vala"
	if (old_value != value) {
#line 792 "HideTracker.c"
		MetaDisplay* _tmp0_;
#line 14 "../src/ShellClients/HideTracker.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 14 "../src/ShellClients/HideTracker.vala"
		_g_object_unref0 (self->priv->_display);
#line 14 "../src/ShellClients/HideTracker.vala"
		self->priv->_display = _tmp0_;
#line 14 "../src/ShellClients/HideTracker.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_hide_tracker_properties[GALA_HIDE_TRACKER_DISPLAY_PROPERTY]);
#line 802 "HideTracker.c"
	}
}

GalaPanelWindow*
gala_hide_tracker_get_panel (GalaHideTracker* self)
{
	GalaPanelWindow* result;
	GalaPanelWindow* _tmp0_;
#line 15 "../src/ShellClients/HideTracker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "../src/ShellClients/HideTracker.vala"
	_tmp0_ = self->priv->_panel;
#line 15 "../src/ShellClients/HideTracker.vala"
	result = _tmp0_;
#line 15 "../src/ShellClients/HideTracker.vala"
	return result;
#line 819 "HideTracker.c"
}

static void
gala_hide_tracker_set_panel (GalaHideTracker* self,
                             GalaPanelWindow* value)
{
	GalaPanelWindow* old_value;
#line 15 "../src/ShellClients/HideTracker.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/ShellClients/HideTracker.vala"
	old_value = gala_hide_tracker_get_panel (self);
#line 15 "../src/ShellClients/HideTracker.vala"
	if (old_value != value) {
#line 15 "../src/ShellClients/HideTracker.vala"
		self->priv->_panel = value;
#line 15 "../src/ShellClients/HideTracker.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_hide_tracker_properties[GALA_HIDE_TRACKER_PANEL_PROPERTY]);
#line 837 "HideTracker.c"
	}
}

enum io_elementary_pantheon_panel_v1_hide_mode
gala_hide_tracker_get_hide_mode (GalaHideTracker* self)
{
	enum io_elementary_pantheon_panel_v1_hide_mode result;
#line 16 "../src/ShellClients/HideTracker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 16 "../src/ShellClients/HideTracker.vala"
	result = self->priv->_hide_mode;
#line 16 "../src/ShellClients/HideTracker.vala"
	return result;
#line 851 "HideTracker.c"
}

void
gala_hide_tracker_set_hide_mode (GalaHideTracker* self,
                                 enum io_elementary_pantheon_panel_v1_hide_mode value)
{
	enum io_elementary_pantheon_panel_v1_hide_mode old_value;
#line 16 "../src/ShellClients/HideTracker.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/ShellClients/HideTracker.vala"
	old_value = gala_hide_tracker_get_hide_mode (self);
#line 16 "../src/ShellClients/HideTracker.vala"
	if (old_value != value) {
#line 16 "../src/ShellClients/HideTracker.vala"
		self->priv->_hide_mode = value;
#line 16 "../src/ShellClients/HideTracker.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_hide_tracker_properties[GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY]);
#line 869 "HideTracker.c"
	}
}

static void
_gala_hide_tracker___lambda105_ (GalaHideTracker* self)
{
	MetaWindow* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	MetaWindow* _tmp4_;
	MetaWindow* _tmp5_;
#line 38 "../src/ShellClients/HideTracker.vala"
	_tmp0_ = self->priv->current_focus_window;
#line 38 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_untrack_focus_window (self, _tmp0_);
#line 39 "../src/ShellClients/HideTracker.vala"
	_tmp1_ = self->priv->_display;
#line 39 "../src/ShellClients/HideTracker.vala"
	_tmp2_ = meta_display_get_focus_window (_tmp1_);
#line 39 "../src/ShellClients/HideTracker.vala"
	_tmp3_ = _tmp2_;
#line 39 "../src/ShellClients/HideTracker.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 39 "../src/ShellClients/HideTracker.vala"
	_g_object_unref0 (self->priv->current_focus_window);
#line 39 "../src/ShellClients/HideTracker.vala"
	self->priv->current_focus_window = _tmp4_;
#line 40 "../src/ShellClients/HideTracker.vala"
	_tmp5_ = self->priv->current_focus_window;
#line 40 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_track_focus_window (self, _tmp5_);
#line 902 "HideTracker.c"
}

static void
__gala_hide_tracker___lambda105__g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 37 "../src/ShellClients/HideTracker.vala"
	_gala_hide_tracker___lambda105_ ((GalaHideTracker*) self);
#line 912 "HideTracker.c"
}

static void
_gala_hide_tracker_schedule_update_meta_window_unmanaged (MetaWindow* _sender,
                                                          gpointer self)
{
#line 45 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_schedule_update ((GalaHideTracker*) self);
#line 921 "HideTracker.c"
}

static void
_gala_hide_tracker___lambda106_ (GalaHideTracker* self,
                                 MetaWindow* window)
{
#line 43 "../src/ShellClients/HideTracker.vala"
	g_return_if_fail (window != NULL);
#line 44 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_schedule_update (self);
#line 45 "../src/ShellClients/HideTracker.vala"
	g_signal_connect_object (window, "unmanaged", (GCallback) _gala_hide_tracker_schedule_update_meta_window_unmanaged, self, 0);
#line 934 "HideTracker.c"
}

static void
__gala_hide_tracker___lambda106__meta_display_window_created (MetaDisplay* _sender,
                                                              MetaWindow* object,
                                                              gpointer self)
{
#line 43 "../src/ShellClients/HideTracker.vala"
	_gala_hide_tracker___lambda106_ ((GalaHideTracker*) self, object);
#line 944 "HideTracker.c"
}

static void
_gala_hide_tracker___lambda107_ (GalaHideTracker* self)
{
	gboolean has_pointer = FALSE;
	GalaPanelWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
#line 51 "../src/ShellClients/HideTracker.vala"
	_tmp0_ = self->priv->_panel;
#line 51 "../src/ShellClients/HideTracker.vala"
	_tmp1_ = gala_panel_window_get_window (_tmp0_);
#line 51 "../src/ShellClients/HideTracker.vala"
	_tmp2_ = _tmp1_;
#line 51 "../src/ShellClients/HideTracker.vala"
	has_pointer = meta_window_has_pointer (_tmp2_);
#line 56 "../src/ShellClients/HideTracker.vala"
	if (self->priv->hovered != has_pointer) {
#line 57 "../src/ShellClients/HideTracker.vala"
		self->priv->hovered = has_pointer;
#line 58 "../src/ShellClients/HideTracker.vala"
		gala_hide_tracker_schedule_update (self);
#line 968 "HideTracker.c"
	}
}

static void
__gala_hide_tracker___lambda107__meta_cursor_tracker_position_invalidated (MetaCursorTracker* _sender,
                                                                           gpointer self)
{
#line 49 "../src/ShellClients/HideTracker.vala"
	_gala_hide_tracker___lambda107_ ((GalaHideTracker*) self);
#line 978 "HideTracker.c"
}

static void
_gala_hide_tracker_schedule_update_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                    gpointer self)
{
#line 62 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_schedule_update ((GalaHideTracker*) self);
#line 987 "HideTracker.c"
}

static GObject *
gala_hide_tracker_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaHideTracker * self;
	MetaDisplay* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	MetaWindow* _tmp4_;
	MetaDisplay* _tmp5_;
	MetaDisplay* _tmp6_;
	MetaCursorTracker* cursor_tracker = NULL;
	MetaDisplay* _tmp7_;
	MetaCursorTracker* _tmp8_;
	MetaCursorTracker* _tmp9_;
	MetaCursorTracker* _tmp10_;
	MetaDisplay* _tmp11_;
	MetaWorkspaceManager* _tmp12_;
#line 32 "../src/ShellClients/HideTracker.vala"
	parent_class = G_OBJECT_CLASS (gala_hide_tracker_parent_class);
#line 32 "../src/ShellClients/HideTracker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 32 "../src/ShellClients/HideTracker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_HIDE_TRACKER, GalaHideTracker);
#line 35 "../src/ShellClients/HideTracker.vala"
	_tmp0_ = self->priv->_display;
#line 35 "../src/ShellClients/HideTracker.vala"
	_tmp1_ = meta_display_get_focus_window (_tmp0_);
#line 35 "../src/ShellClients/HideTracker.vala"
	_tmp2_ = _tmp1_;
#line 35 "../src/ShellClients/HideTracker.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 35 "../src/ShellClients/HideTracker.vala"
	_g_object_unref0 (self->priv->current_focus_window);
#line 35 "../src/ShellClients/HideTracker.vala"
	self->priv->current_focus_window = _tmp3_;
#line 36 "../src/ShellClients/HideTracker.vala"
	_tmp4_ = self->priv->current_focus_window;
#line 36 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_track_focus_window (self, _tmp4_);
#line 37 "../src/ShellClients/HideTracker.vala"
	_tmp5_ = self->priv->_display;
#line 37 "../src/ShellClients/HideTracker.vala"
	g_signal_connect_object ((GObject*) _tmp5_, "notify::focus-window", (GCallback) __gala_hide_tracker___lambda105__g_object_notify, self, 0);
#line 43 "../src/ShellClients/HideTracker.vala"
	_tmp6_ = self->priv->_display;
#line 43 "../src/ShellClients/HideTracker.vala"
	g_signal_connect_object (_tmp6_, "window-created", (GCallback) __gala_hide_tracker___lambda106__meta_display_window_created, self, 0);
#line 48 "../src/ShellClients/HideTracker.vala"
	_tmp7_ = self->priv->_display;
#line 48 "../src/ShellClients/HideTracker.vala"
	_tmp8_ = meta_cursor_tracker_get_for_display (_tmp7_);
#line 48 "../src/ShellClients/HideTracker.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 48 "../src/ShellClients/HideTracker.vala"
	cursor_tracker = _tmp9_;
#line 49 "../src/ShellClients/HideTracker.vala"
	_tmp10_ = cursor_tracker;
#line 49 "../src/ShellClients/HideTracker.vala"
	g_signal_connect_object (_tmp10_, "position-invalidated", (GCallback) __gala_hide_tracker___lambda107__meta_cursor_tracker_position_invalidated, self, 0);
#line 62 "../src/ShellClients/HideTracker.vala"
	_tmp11_ = self->priv->_display;
#line 62 "../src/ShellClients/HideTracker.vala"
	_tmp12_ = meta_display_get_workspace_manager (_tmp11_);
#line 62 "../src/ShellClients/HideTracker.vala"
	g_signal_connect_object (_tmp12_, "active-workspace-changed", (GCallback) _gala_hide_tracker_schedule_update_meta_workspace_manager_active_workspace_changed, self, 0);
#line 32 "../src/ShellClients/HideTracker.vala"
	_g_object_unref0 (cursor_tracker);
#line 32 "../src/ShellClients/HideTracker.vala"
	return obj;
#line 1064 "HideTracker.c"
}

static void
gala_hide_tracker_class_init (GalaHideTrackerClass * klass,
                              gpointer klass_data)
{
#line 8 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/ShellClients/HideTracker.vala"
	g_type_class_adjust_private_offset (klass, &GalaHideTracker_private_offset);
#line 8 "../src/ShellClients/HideTracker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_hide_tracker_get_property;
#line 8 "../src/ShellClients/HideTracker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_hide_tracker_set_property;
#line 8 "../src/ShellClients/HideTracker.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_hide_tracker_constructor;
#line 8 "../src/ShellClients/HideTracker.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_hide_tracker_finalize;
#line 8 "../src/ShellClients/HideTracker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_HIDE_TRACKER_DISPLAY_PROPERTY, gala_hide_tracker_properties[GALA_HIDE_TRACKER_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/ShellClients/HideTracker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_HIDE_TRACKER_PANEL_PROPERTY, gala_hide_tracker_properties[GALA_HIDE_TRACKER_PANEL_PROPERTY] = g_param_spec_object ("panel", "panel", "panel", GALA_TYPE_PANEL_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/ShellClients/HideTracker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY, gala_hide_tracker_properties[GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY] = g_param_spec_int ("hide-mode", "hide-mode", "hide-mode", G_MININT, G_MAXINT, IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_NEVER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_signals[GALA_HIDE_TRACKER_HIDE_SIGNAL] = g_signal_new ("hide", GALA_TYPE_HIDE_TRACKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 8 "../src/ShellClients/HideTracker.vala"
	gala_hide_tracker_signals[GALA_HIDE_TRACKER_SHOW_SIGNAL] = g_signal_new ("show", GALA_TYPE_HIDE_TRACKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1093 "HideTracker.c"
}

static void
gala_hide_tracker_instance_init (GalaHideTracker * self,
                                 gpointer klass)
{
#line 8 "../src/ShellClients/HideTracker.vala"
	self->priv = gala_hide_tracker_get_instance_private (self);
#line 16 "../src/ShellClients/HideTracker.vala"
	self->priv->_hide_mode = IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_NEVER;
#line 18 "../src/ShellClients/HideTracker.vala"
	self->priv->hovered = FALSE;
#line 20 "../src/ShellClients/HideTracker.vala"
	self->priv->overlap = FALSE;
#line 21 "../src/ShellClients/HideTracker.vala"
	self->priv->focus_overlap = FALSE;
#line 22 "../src/ShellClients/HideTracker.vala"
	self->priv->focus_maximized_overlap = FALSE;
#line 26 "../src/ShellClients/HideTracker.vala"
	self->priv->update_timeout_id = (guint) 0;
#line 1114 "HideTracker.c"
}

static void
gala_hide_tracker_finalize (GObject * obj)
{
	GalaHideTracker * self;
#line 8 "../src/ShellClients/HideTracker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_HIDE_TRACKER, GalaHideTracker);
#line 14 "../src/ShellClients/HideTracker.vala"
	_g_object_unref0 (self->priv->_display);
#line 24 "../src/ShellClients/HideTracker.vala"
	_g_object_unref0 (self->priv->current_focus_window);
#line 8 "../src/ShellClients/HideTracker.vala"
	G_OBJECT_CLASS (gala_hide_tracker_parent_class)->finalize (obj);
#line 1129 "HideTracker.c"
}

 G_GNUC_NO_INLINE static GType
gala_hide_tracker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaHideTrackerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_hide_tracker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaHideTracker), 0, (GInstanceInitFunc) gala_hide_tracker_instance_init, NULL };
	GType gala_hide_tracker_type_id;
	gala_hide_tracker_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaHideTracker", &g_define_type_info, 0);
	GalaHideTracker_private_offset = g_type_add_instance_private (gala_hide_tracker_type_id, sizeof (GalaHideTrackerPrivate));
	return gala_hide_tracker_type_id;
}

GType
gala_hide_tracker_get_type (void)
{
	static gsize gala_hide_tracker_type_id__once = 0;
	if (g_once_init_enter (&gala_hide_tracker_type_id__once)) {
		GType gala_hide_tracker_type_id;
		gala_hide_tracker_type_id = gala_hide_tracker_get_type_once ();
		g_once_init_leave (&gala_hide_tracker_type_id__once, gala_hide_tracker_type_id);
	}
	return gala_hide_tracker_type_id__once;
}

static void
_vala_gala_hide_tracker_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GalaHideTracker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_HIDE_TRACKER, GalaHideTracker);
#line 8 "../src/ShellClients/HideTracker.vala"
	switch (property_id) {
#line 8 "../src/ShellClients/HideTracker.vala"
		case GALA_HIDE_TRACKER_DISPLAY_PROPERTY:
#line 8 "../src/ShellClients/HideTracker.vala"
		g_value_set_object (value, gala_hide_tracker_get_display (self));
#line 8 "../src/ShellClients/HideTracker.vala"
		break;
#line 8 "../src/ShellClients/HideTracker.vala"
		case GALA_HIDE_TRACKER_PANEL_PROPERTY:
#line 8 "../src/ShellClients/HideTracker.vala"
		g_value_set_object (value, gala_hide_tracker_get_panel (self));
#line 8 "../src/ShellClients/HideTracker.vala"
		break;
#line 8 "../src/ShellClients/HideTracker.vala"
		case GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY:
#line 8 "../src/ShellClients/HideTracker.vala"
		g_value_set_int (value, gala_hide_tracker_get_hide_mode (self));
#line 8 "../src/ShellClients/HideTracker.vala"
		break;
#line 1182 "HideTracker.c"
		default:
#line 8 "../src/ShellClients/HideTracker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/ShellClients/HideTracker.vala"
		break;
#line 1188 "HideTracker.c"
	}
}

static void
_vala_gala_hide_tracker_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	GalaHideTracker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_HIDE_TRACKER, GalaHideTracker);
#line 8 "../src/ShellClients/HideTracker.vala"
	switch (property_id) {
#line 8 "../src/ShellClients/HideTracker.vala"
		case GALA_HIDE_TRACKER_DISPLAY_PROPERTY:
#line 8 "../src/ShellClients/HideTracker.vala"
		gala_hide_tracker_set_display (self, g_value_get_object (value));
#line 8 "../src/ShellClients/HideTracker.vala"
		break;
#line 8 "../src/ShellClients/HideTracker.vala"
		case GALA_HIDE_TRACKER_PANEL_PROPERTY:
#line 8 "../src/ShellClients/HideTracker.vala"
		gala_hide_tracker_set_panel (self, g_value_get_object (value));
#line 8 "../src/ShellClients/HideTracker.vala"
		break;
#line 8 "../src/ShellClients/HideTracker.vala"
		case GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY:
#line 8 "../src/ShellClients/HideTracker.vala"
		gala_hide_tracker_set_hide_mode (self, g_value_get_int (value));
#line 8 "../src/ShellClients/HideTracker.vala"
		break;
#line 1220 "HideTracker.c"
		default:
#line 8 "../src/ShellClients/HideTracker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/ShellClients/HideTracker.vala"
		break;
#line 1226 "HideTracker.c"
	}
}

